#pragma once
#ifndef __CTC_H
#define __CTC_H
#include "ctcbase.h"
const int
	t0_unknown=-1,
	t0_end=-2,
	t0_i8=0,
	t0_u8=1,
	t0_i16=2,
	t0_u16=3,
	t0_i32=4,
	t0_u32=5,
	t0_i64=6,
	t0_u64=7,
	t0_f32=8,
	t0_f64=9,
	t0_void=10,
	t0_v128=11,
	t0_N=12,
	//doesn't allow derivative types
	t0_type=13,
	//only used in template,even pointer is invalid
	t0_typename=t0_type,
	t0_Int=14,
	t0_unknownref=15,
	t0_unknowncref=16,
	//only for BE
	t0_madummy=17,
	t0_reserved=18,
	t0_logicdummy=19,
	t0_iptr=t0_i32,
	t0_uptr=t0_u32,
	t0_char=t0_i8,
	gt_line=0,
	gt_functemp=1,
	gt_clstemp=2,
	gt_statementish=gt_functemp,
	gt_toch=3,
	gt_block=4,
	gtf_mode=7,
	gtf_stripindent=8,
	gtf_addlineinfo=16,
	gtf_discard=32,
	gtf_noskip_for_discard=64,
	gtf_noncode=128,
	gtf_noskip_discard=gtf_discard|gtf_noskip_for_discard,
	gtf_code=gtf_stripindent|gtf_addlineinfo,
	tranid_decl=0,//does nothing when id
	tranid_stat=1,
	tranid_expr=2,
	tranid_builtin_only=3,
	decl_normal=0,
	kw_struct=11,
	kw_union=12,
	kw_static=13,
	kw_class=27,
	ssaopt_build=1,
	ssaopt_flatten=2,
	ssaopt_keeppure=4,
	clone_vars=1,
	clone_whole=2,//assumes no outside jump
	clone_nofescope=4,
	cloneop_add_finally=8,
	cloneop_en_masse=16;

typedef unsigned int u32;
void*& estate(cfunc* pf,u32 tag){
	return *get_func_estate(pf,tag);
}

void*& estate(cfunc* pf,char* s){
	return estate(pf,hashstr(s));
}

typedef TCode* ccode;

/*
list of named output buffers:
	cbeStructFwd
	cbeTypedef
	cbeFuncFwd
	cbeGdecl
	cbeGdecl2
	cbeGbody
	cbeFdecl
	cbeFbody
*/
template<class T>
struct clisp{
	clisp<T>* x;
	union{
		clisp<T>* tail;
		clisp<T>* w;
	};
	T a;
};

template<class T>
inline clisp<T>* cons(const T& a){
	clisp<T>* p=(clisp<T>*)poolalloc2(sizeof(clisp<T>));
	p->a=a;
	p->tail=p;
	p->x=NULL;
	return p;
}

template<class T>
inline clisp<T>* cat(clisp<T>* a,clisp<T>* b)
{
	if (!a) return b;
	if (!b) return a;
	/*if !(a.w.x==null&&b.w.x==null):
		warning('invalid code concatenation')
		hEx 'cc'*/
	clisp<T>* t =a->w;a->w=b->w;b->w=t;t->x=b;
	return a;
}

template<class T>
inline clisp<T>* behead(clisp<T> * a)
{
	clisp<T> * ret = a->x;
	if (ret)
		ret->w = a->w;
	return ret;
}

template<class T>
inline clisp<T> * decapitate(clisp<T> * a)
{
	clisp<T> * ret = a->x;
	if (ret)
		ret->w = a->w;
	//!!!!!!!! Warning: Not freeing memory!
	//delete a;
	return ret;
}

template<class T>
inline clisp<T>* remove(clisp<T> * hd, clisp<T>* a)
{
	if (a->x)
		a->x->w = a->w;
	else
		hd->w = a->w;
	if (a!=hd)
		a->w->x = a->x;
	else
	{
		hd = a->x;
		if (hd)
			hd->w = a->w;
	}
	return hd;
}

template<class T>
inline clisp<T>* chop(clisp<T> * hd, clisp<T>* a)
{
	if (hd==a)
		return 0;
	if (!a)
		return hd;
	clisp<T>* aw = a->w;
	a->w = hd->w;
	aw->x = 0;
	hd->w = aw;
	return hd;
}

//note: callpf0 checks for overloading, callraw doesn't
#endif
