#include <windows.h>
#include <assert.h>
#include "../ctc.h"

class CTestBrand:public CBEBrand{
public:
virtual int __cdecl getFlags();
virtual int __cdecl detect();
virtual void __cdecl writeFuncTitle(struct cfunc*);
virtual void __cdecl writeVarHack();
virtual void __cdecl writeAlign(int);
virtual void __cdecl writeAlign2(int);
virtual void __cdecl writeProlog();
virtual void __cdecl writeEpilog();
virtual void __cdecl writeF32(float);
virtual void __cdecl writeF64(double);
virtual void __cdecl writeExtType(int);
virtual int __cdecl writeExtraParam(struct cfunc*);
virtual void __cdecl onEmptyStruct();
virtual ctc_string* __cdecl getCmdLine(char*,char*);
virtual void __cdecl callCC(char*,char*);
virtual void __cdecl optimize();
virtual char* __cdecl targetName();
};

int __cdecl CTestBrand::getFlags(){
	return 0;
}

/*
void detectHardware()
	const
		CUDA_SUCCESS=0
	hdll=LoadLibraryA("nvcuda.dll")
	if !hdll:return
	cuDevice=0
	deviceCount=0
	cuInit=int()stdcall(int)GetProcAddress(hdll,"cuInit")
	if !cuInit||CUDA_SUCCESS!=cuInit(0):return
	cuDeviceGetCount=int()stdcall(int*)GetProcAddress(hdll,"cuDeviceGetCount")
	if cuDeviceGetCount:cuDeviceGetCount(&deviceCount)
	if deviceCount==0:return
	cuDeviceGet=int()stdcall(int*,int)GetProcAddress(hdll,"cuDeviceGet")
	cuDeviceComputeCapability=int()stdcall(int*,int*,int)GetProcAddress(hdll,"cuDeviceComputeCapability")
	if !cuDeviceGet||!cuDeviceComputeCapability:return
	for dev=0:deviceCount-1
		major=minor=0
		cuDevice=0
		if CUDA_SUCCESS!=cuDeviceGet(&cuDevice,dev):continue
		if CUDA_SUCCESS!=cuDeviceComputeCapability(&major,&minor,cuDevice):continue
		if major>=2:
			parser.state('cuda.fermi')=(void*)1
			return
*/

int __cdecl CTestBrand::detect(){
	/*
		if .exename:return 1
		if !back.vcbrand.detect():
			return 0
		ret=(string)NULL
		char[261] buf
		if !GetEnvironmentVariableA("CUDA_BIN_PATH",buf,260):goto nocudabin
		ret=findexe((char*)(new string(buf)+"\\nvcc.exe"))
		if !ret:
			ret=findexe((char*)(new string(buf)+"\\..\\bin\\nvcc.exe"))
		:nocudabin
		if !ret:ret=findexe("nvcc.exe")
		.exename=ret
		if ret:
			s=new string((char*)ret)
			for i=s.n-1:-1:0
				if s[i]=='\\':
					s.resize(i+1)
					break
			write-strappendf(s;"..\\include\\sm_2*.*")
			hf=FindFirstFileA((char*)s,&WIN32_FIND_DATA fd)
			if hf!=INVALID_HANDLE_VALUE:
				FindClose(hf)
				.detectHardware()
		return !!.exename
	*/
	return 1;
}

void __cdecl CTestBrand::writeFuncTitle(struct cfunc* pf){
	char* s=(char*)estate(pf,"c-function-title");
	if(s){
		cbePrintf("%s ",s);
	}else{
		cbePrintf("%s ","static");
	}
}

void __cdecl CTestBrand::writeVarHack(){}
void __cdecl CTestBrand::writeAlign(int alg){
	cbePrintf("%s%d%s","__declspec(align(",alg,")) ");
}

void __cdecl CTestBrand::writeAlign2(int alg){
}

void __cdecl CTestBrand::writeProlog(){
	/*
	cbeSetKeyword("this")
	cbeSetKeyword("__edid")
	cbeSetKeyword("__param")
	cbeSetKeyword("__parambig")
	cbeSetKeyword("__sharedbase")
	if parser.cuda_hasedid:
		writec('extern "C" __device__ int __edid;\n')
	for i=0:parser.ntexunit-1
		writec('extern "C" texture<int,1,cudaReadModeElementType> __tex',i,';\n');
	for i=0:parser.nsurfunit-1
		writec('extern "C" surface<void,2> __surf',i,';\n');
	*/
}

void __cdecl CTestBrand::writeEpilog(){
	void* bk=cbeGetOutputBuffer();
	cbeSetOutputBuffer(cbeGetBufferByName("cbeTypedef"));
	/*if parser.cuda_bigparams.n:
		writec('extern "C" __constant__ union{\n')
		for i=0:parser.cuda_bigparams.n-1
			cbeGenType(parser.cuda_bigparams[i])
			writec(' as_',i,';\n')
		writec('}__parambig;\n')*/
	cbeSetOutputBuffer(bk);
}

void __cdecl CTestBrand::writeF32(float f){
	int a=*(int*)&f;
	int e=((a>>23)&0xff);
	if(e>=0xfe||e<=1){
		cbePrintf("%s%d%s","__int_as_float(",a,")");
	}else{
		cbePrintf("%.8ef",(double)f);
	}
}

void __cdecl CTestBrand::writeF64(double d){
	long long a=*(long long *)&d;
	int e=((int)(a>>53)&0x3ff);
	if(e>=0x3fe||e<=1){
		cbePrintf("%s%d%s","__longlong_as_double(",a,"LL)");
	}else{
		cbePrintf("%.20e",d);
	}
}

void __cdecl CTestBrand::writeExtType(int t){
	if(t==t0_i64){cbePrintf("long long");}
	else if(t==t0_u64){cbePrintf("unsigned long long");}
	else{
		assert(t==t0_v128);
		cbePrintf("__m128");
	}
}

int __cdecl CTestBrand::writeExtraParam(struct cfunc*){
	/*
		vgpuparam=(cvar*)pf.estate(Stru32'CUDA-vgpuparam')
		if vgpuparam:
			t=(ttype)pf.estate(Stru32'kernel-paramtype')
			cbeGenType(t)
			writec(" __param")
			vgpuparam.cbename=getid('__param')
		vbigparam=(cvar*)pf.estate(Stru32'CUDA-vbigparam')
		if vbigparam:
			vbigparam.cbename=vbigparam.vid
			cbeMakeDecared(vbigparam.t)
		return 0
	*/
	return 0;//return 1 to skip writing of the original parameters
}

void __cdecl CTestBrand::onEmptyStruct(){
	//print some filling member for a struct with size 0
	cbePrintf("int non_empty;");
}

ctc_string* __cdecl CTestBrand::getCmdLine(char* sexe,char* sc){
	/*
		if !.exename:return NULL
		ret=write-strprintf('"',.exename,'" --cubin -O',parser.olevel)
		sextraopt=parser.state('nvcc-option')
		if .need_atomic&&(!sextraopt||!strstr(sextraopt,"-arch")):
			write-strappendf(ret;' -arch=sm_12 ')
		if sextraopt:write-strappendf(ret;' ',(char*)sextraopt,' ')
		if back.vcbrand.vcbinpath.n>0:
			write-strappendf(ret;' -ccbin "',back.vcbrand.vcbinpath,'cl.exe"')
		write-strappendf(ret;' --use_fast_math -o "',sexe,'" "',sc,'"')
		char[64] buf
		if !GetEnvironmentVariableA("WindowsSdkDir",buf,32):
			sbat=genTempName(".callnvcc.bat",0)
			f=fopen((char*)sbat,"w")
			writeln(f,'@call "',back.vcbrand.vcbinpath,'vcvars32.bat">NUL')
			writeln(f,'@',ret)
			fclose(f)
			.todel=sbat
			ret=new string("\"")+sbat+"\""
		return ret
	*/
	return stringFromPChar("");
}

void __cdecl CTestBrand::callCC(char* sexe,char* sc){
	callCC_default(this,sexe,sc);
	//if .todel:remove((char*)(.todel))
}

void __cdecl CTestBrand::optimize(){
	if(get_olevel()>=2){
		_ssastdopt(ssaopt_build|ssaopt_flatten);
	}else{
		_ssastdopt(ssaopt_build);
	}
	livesplit();
	/*
		//vector is the next step
		front.hasvector=1
		ssastdopt(ssaopt_build|ssaopt_flatten)
		livesplit()
		//hack vector vars
		foreach v in &front.allssavar
			if v.t==t0_v128:
				tvec=(ttype)v.estate(Stru32'vector-type')
				if tvec:v.t=tvec
	*/
}

char* __cdecl CTestBrand::targetName(){
	return "TEST";
}

/////////////////////////////////////////
class CSPAPTEST:public CSPAPHandler{
public:
	CTestBrand* testguy;
	virtual char* __cdecl getName();
	virtual struct TCode* __cdecl genKernel(struct cpass*,struct cspappass*);
	virtual void __cdecl compileKernels(struct cfunc**,int);
	virtual void __cdecl onEnable();
	CSPAPTEST(){
		testguy=new CTestBrand;
		__refcnt=1;
		enabled=0;
	}
};

char* __cdecl CSPAPTEST::getName(){
	//this name is used in /meta.enableTarget("TEST",1)
	return "<TEST>";
}

ccode __cdecl CSPAPTEST::genKernel(cpass* pp,cspappass* psp){
	//this function generates LAUNCHER code
#if 0
	with parser
	#define align(a,b) ((b+(a-1))&-(a))
	pfkrnl=.makefvv()
	//pre-translation
	code=psp.ckrnl
	isempty=1
	foreach pi in code
		if pi.f==.fedid:
			if pp.reachbar.n<=1:
				freeccd(pi)
				code=remove(code,I)
			else
				assert(pi.b[0].what==copr.cns)
				.cuda_hasedid=1
				peedid=&.call(.fasm,list![&.makeerstr('__edid='),&.makeeri(pi.b[0].c.ci32),
					&.makeerstr(";"),&.makeerstr("@prelive")])
				code=chop(code,I)
				cdi=behead(I)
				code=list(code,peedid.code,cdi)
		elif pi.op!=ccd.oplbl:
			isempty=0
	vrank=pp.rk
	vsize=.vsize
	szsm=0;algsm=4
	foreach pi in code
		:again
		if pi.f==.fallocsm:
			assert(pi.b[0].what==copr.cns&&pi.b[1].what==copr.cns)
			sz=pi.b[0].c.ciptr
			alg=pi.b[1].c.ciptr
			algsm=max(algsm,alg)
			szsm=align(alg,szsm)
			ofs=szsm
			szsm+=sz
			cdpi=.call(.fmov,list![&.makeerv(pi.a),
				castto(&.call('$$spap.detail.cudevSetShared',list![&.makeeri(ofs)]),pi.a.t)
				]).code
			code=chop(code,I)
			freeccd(pi)
			I=decapitate(I)
			code=list(code,cdpi,I)
			if !I:break
			pi=I.a
			goto again
	if szsm:
		szsm=align(algsm,szsm)
		code=list(.call('$$spap.detail.cudevDeclShared',list![
			&.makeeri(algsm),&.makeeri(szsm)]).code,code)
	//substitute to the pers-thread template
	vkrnl=make cvar(t0_voidp)
	vpp=make cvar(t0_voidp)
	vszp=make cvar(t0_iptr)
	krnlname=psp.findOption('cudaLaunchMethod')
	if !krnlname:
		sfname='$$spap.detail.cudevStdKernel'
	else
		if !strchr(krnlname.s,int'.')&&!strchr(krnlname.s,int'$'):
			str=write-strprintf('$$spap.detail.',krnlname.s)
		else
			str=write-strprintf(krnlname.s)
		sfname=(char*)str
	cdtemplate=funccode(sfname)
	if !cdtemplate:
		error!(pp.epos,"CUDA launch method ",krnlname.s," is not found")
	fillepos_force(cdtemplate,pp.epos)
	code=substitute(cdtemplate,
		list!["__kernel","__param","__szparam","__thread_rank","__thread_size"],
			list![vkrnl,vpp,vszp,vrank,vsize],
		list!["kernel body","param maker"],
		list![(void*)code,(void*)list(make ccd(.flaunchsep,NULL,make!clist(copr)))])
	with unwrapTemplate(code)
		cdlaunch=.cdlaunch
		code=.cdkrnl
	//for cdlaunch ~ code params...
	foreach pi in cdlaunch
		if pi.f==.flaunchsep:
			cdextrareq=chop(cdlaunch,I)
			psp.creq=list(psp.creq,cdextrareq)
			cdlaunch=decapitate(I)
			break
	//use the global system!
	psp.ckrnl=code
	vrank=pp.rk
	vsize=.vsize
	//kernel gen
	kw=kernelWrap(psp)
	tparam=kw.vparam.t
	assert(tis(tparam,ctype.tstruct))
	//hack it to fool CUDA
	((ctype*)tparam).sd.alg=4
	code=kw.cdkrnl
	sz=_sizeof(tparam)
	//.cuda_maxparam=max(.cuda_maxparam,sz)
	vgpuparam=make cvar(tparam)
	vgpuparam._tags|=cvar.vtag_noflat
	peaddr=&.call(.flea,list![&.makeerv(vgpuparam)])
	if sz<=96:
		pfkrnl.estate(Stru32'CUDA-vgpuparam')=vgpuparam
	else
		.cuda_bigparams.add(tparam)
		sprintf(char[64]buf,'__parambig.as_%d',.cuda_bigparams.n-1)
		vgpuparam.vid=getid(buf)
		pfkrnl.estate(Stru32'CUDA-vbigparam')=vgpuparam
	peaddr=&.call(.fmov,list![&.makeerv(kw.vaddr0),castto(peaddr,t0_iptr)])
	code2=list(peaddr.code,code)
	//the file name may contain all kinds of weird characters, don't do this:(
	//if parser.keeptemp:
	//	str=write-strprintf("/*",eposstr(pp.epos),"*/")
	//	code2=list(
	//		.call(.fasm,list![&.makeerstr(str.c_str()),
	//			&.makeerstr("@prelive")]).code,code2)
	if isempty:
		//empty kernel optimization
		cdlaunch=NULL
	//CUDA compilation is destructive, don't get original vars dirty
	code=clone(clone_vars,code2)
	discardcode(code2)
	appendfunc(pfkrnl,code,"")
	pfkrnl.estate(Stru32'kernel-paramtype')=(void*)tparam
	pfkrnl.estate(Stru32'kernel-brand')="CUDA"
	pier=make cinitializer()
	pier.t=.makearraytype(t0_iptr,4)
	pier.pdata=zalloc(_sizeof(pier.t))
	pd=(iptr*)pier.pdata
	pd[1]=Stru32'CUDA'
	pd[3]=psp.ntexture
	with cexpres erkrnl
		.clear()
		.makedata(pier)
	pfkrnl.estate(Stru32'kernel-data')=pier
	epos2nlc(pp.epos,int lerr,int cerr)
	write-sprintf(buf;"CUDAkrnl_",lerr)
	pfkrnl.id=getid(buf)
	pfkrnl.estate(Stru32'c-function-title')='extern "C" __global__'
	.krnls.add(pfkrnl)
	cdlaunch=list(kw.cdmkparam,
		.call(.fmov,list![&.makeerv(vkrnl),&erkrnl]).code,
		.call(.fmov,list![&.makeerv(vpp),&.call(.flea,list![&.makeerv(kw.vparam)])]).code,
		.call(.fmov,list![&.makeerv(vszp),&.makeeri(_sizeof(tparam))]).code,
		cdlaunch)
	if pp.reachbar.n>1:
		//copy back the thing to vedid
		cdlaunch=list(cdlaunch,
			.call(.fmov,list![&.makeerv(.vedid),
				&.call('$$spap.detail.cudaGetEndBarrier',make!clist(cexpres*))]).code)
	fillepos_force(cdlaunch,pp.epos)
	return list(psp.creq,cdlaunch,psp.creqe)
#endif
	cexpres er;
	ExprList erl;
	erl.d=NULL;erl.n=0;
	call_str(&er,"$$test.testfunc",&erl);
	return er.code;
}

void __cdecl CSPAPTEST::compileKernels(cfunc** ks,int n){
	/*with parser
	testguy=..testguy
	bkb=back.cbeBrand
	back.cbeBrand=(CBEBrand*)testguy
	bk=parser.curtarget
	parser.curtarget=parser.state('target-CUDA')
	back.cbeLineInfo=!!parser.enable_debug
	a_cu=genTempName(".cu",1)
	a_cubin=genTempName(".cubin",1)
	old_cu=(char*)NULL
	sz_old_cu=0
	f=fopen((char*)a_cu,"rb")
	if f:
		fseek(f,0,SEEK_END)
		sz=ftell(f)
		fseek(f,0,SEEK_SET)
		fread(old_cu=new char[sz+1],sz,1,f)
		old_cu[sz]=0
		fclose(f)
		sz_old_cu=sz
	cbeBegin()
	cbeSetExtraDeclaration(parser.state('CUDA.extra_include'))
	//md5=makemd5()
	//md5.update((char*)a_cu,strlen((char*)a_cu)+1)
	//digest=md5.final()
	//strcpy(char[64]buf,"g_")
	//for i=0:15
	//	sprintf(buf+2+i*2,"%02x",digest[i])
	//strcat(buf,"_")
	//back.cbe_prefix=buf
	back.cbe_prefix="g_cu_"//buf
	bko=parser.olevel;parser.olevel=2
	for i=0:n-1
		//cbeCompile(ks[i])
		back.add_depend(ks[i])
	for(i=0;i<back.tocompile.n;i++)
		pf=back.tocompile[i]
		cbeCompile(pf)
	parser.olevel=bko
	cbeEnd((char*)a_cu)
	back.cbe_prefix="g_"
	parser.curtarget=bk
	back.cbeBrand=bkb
	//////////////////////////////
	//detect .cu change
	new_cu=(char*)NULL
	sz_new_cu=0
	f=fopen((char*)a_cu,"rb")
	if f:
		fseek(f,0,SEEK_END)
		sz=ftell(f)
		fseek(f,0,SEEK_SET)
		fread(new_cu=new char[sz+1],sz,1,f)
		new_cu[sz]=0
		fclose(f)
		sz_new_cu=sz
	//writeln(sz_old_cu,' ',sz_new_cu,' ',memcmp(old_cu,new_cu,sz_old_cu))
	attr=-1
	if back.outname:
		//detects VC rebuild, disabled for now
		attr=GetFileAttributesA(back.outname)
	else
		attr=0
	if attr!=-1&&sz_old_cu==sz_new_cu&&old_cu&&new_cu&&memcmp(old_cu,new_cu,sz_old_cu)==0:
		//CUDA file not changed at all, don't recompile
		f=fopen((char*)a_cubin,"rb")
		if f:
			fclose(f)
			if testguy.todel:
				remove((char*)(testguy.todel))
			if old_cu:delete old_cu
			if new_cu:delete new_cu
			goto skip_nvcc
	if old_cu:delete old_cu
	if new_cu:delete new_cu
	if !back.vcbrand.detect():
		error("vc not found, nvcc won't run, ",a_cu," is generated but I can't compile it")
	if !testguy.detect():
		error("nvcc not found, ",a_cu," is generated but I can't compile it")
	bkt=parser.keeptemp
	parser.keeptemp=1
	testguy.callCC((char*)a_cubin,(char*)a_cu)
	parser.keeptemp=bkt
	:skip_nvcc
	f=fopen((char*)a_cubin,"rb")
	if !f:error("somehow nvcc completed without generating output, CUDA too new?")
	fseek(f,0,SEEK_END)
	szcubin=ftell(f)
	fseek(f,0,SEEK_SET)
	pbincode=make cinitializer()
	pbincode.t=.makearraytype(t0_i8,szcubin+8)
	pbincode.pdata=perm.alloc(_sizeof(pbincode.t))
	fread(pbincode.pdata,szcubin,1,f)
	memset(((char*)pbincode.pdata)+szcubin,0,8)
	fclose(f)
	//if !.keeptemp:remove((char*)a_cubin)
	//fill module desc
	pcubin=make cinitializer()
	pcubin.t=.makearraytype(t0_iptr,5+n)
	pcubin.pdata=zalloc(_sizeof(pcubin.t))
	((iptr*)pcubin.pdata)[1]=Stru32'CUDA'
	with pcubin.ptrs.add()
		.ofs=sizeof(iptr)*2
		.idef.what=cindef.data
		.idef.pinit=pbincode
	((iptr*)pcubin.pdata)[3]=.ntexunit+(.nsurfunit<<16)
	((iptr*)pcubin.pdata)[4]=n
	for i=0:n-1
		//fill kernel desc
		pfkrnl=ks[i]
		pier=(cinitializer*)pfkrnl.estate(Stru32'kernel-data')
		*(iptr*)pier.pdata=i
		with pier.ptrs.add()
			.ofs=sizeof(iptr)*2
			.idef.what=cindef.data
			.idef.pinit=pcubin
		//fill kernel name
		id=(tsymbol)pfkrnl.estate(Stru32'cname')
		with pcubin.ptrs.add()
			.ofs=sizeof(iptr)*(5+i)
			.idef.what=cindef.string
			.idef.str=id.s
			.idef.strsz=id.lg+1
	with cexpres erdata
		.clear()
		.makedata(pcubin)
	.global_init=list(
		.call('$$system.detail.initSpapModule',list![&.call(.flea,list![&erdata])]).code,
		.global_init)
	.global_done=list(
		.global_done,
		.call('$$spap.detail.spapUnloadModule',list![&.call(.flea,list![&erdata])]).code)
	//getmodule interface
	pf=(cmetaf*)(.state('metaf-getcudamodule'))
	if pf:
		initfunc(pf)
		with copr o
			.what=copr.indef
			.idef.what=cindef.data
			.idef.pinit=pcubin
		cdgm=list(make ccd(.flea,pf.vret,list[o]))
		appendfunc(pf,cdgm,"")
	*/
}
void __cdecl CSPAPTEST::onEnable(){
	if(enabled){testguy->detect();}
}

extern "C"{
__declspec(dllexport) void __cdecl prepare(){
	CSPAPTEST* psp=new CSPAPTEST;
	installSpapHandler(psp);
}
}

int __stdcall DllMain(
HINSTANCE hinstDLL,
DWORD fdwReason,
void *lpvReserved){
	return 1;
}
