//emulate require cuda features
//todo: 3D surface support
//todo: emulate i64 texture
//todo: scan vs multi-GPU incompatibility
uses spap,cuda,windows
If !compiler.getcmdlineoption("CUBSGP_NO_GL"):uses gl
autouses cuda
autouses spap
static detail
using detail
typedef int cudaError_t
/
	meta.enableTarget("CPU",0)
	if meta.state('cuda.fermi'):
		meta.state('nvcc-option')=' -arch=sm_20 '
const
	RANK_REASSIGNED=1
	CU_AD_FORMAT_UNSIGNED_INT8  = 0x01,
	CU_AD_FORMAT_UNSIGNED_INT16 = 0x02,
	CU_AD_FORMAT_UNSIGNED_INT32 = 0x03,
	CU_AD_FORMAT_SIGNED_INT8    = 0x08,
	CU_AD_FORMAT_SIGNED_INT16   = 0x09,
	CU_AD_FORMAT_SIGNED_INT32   = 0x0a,
	CU_AD_FORMAT_HALF           = 0x10,
	CU_AD_FORMAT_FLOAT          = 0x20
	CU_TR_ADDRESS_MODE_WRAP = 0,
	CU_TR_ADDRESS_MODE_CLAMP = 1,
	CU_TR_ADDRESS_MODE_MIRROR = 2,
	CU_TR_FILTER_MODE_POINT = 0,
	CU_TR_FILTER_MODE_LINEAR = 1
	CUDA_ARRAY3D_2DARRAY=0x01
	CUDA_ARRAY3D_SURFACE_LDST=0x02
	CU_TRSA_OVERRIDE_FORMAT =0x01
	CU_TRSF_READ_AS_INTEGER =        0x01
	CU_TRSF_NORMALIZED_COORDINATES = 0x02
	cudaMemcpyHostToHost=0
	cudaMemcpyHostToDevice=1
	cudaMemcpyDeviceToHost=2
	cudaMemcpyDeviceToDevice=3
	cudaChannelFormatKindSigned=0
	cudaChannelFormatKindUnsigned=1
	cudaChannelFormatKindFloat=2
	cudaAddressModeWrap=0
	cudaAddressModeClamp=1
	cudaFilterModePoint=0
	cudaFilterModeLinear=1
	cudaReadModeElementType=1
	cudaReadModeNormalizedFloat=0
	cudaBoundaryModeZero = 0
	cudaBoundaryModeClamp = 1
	cudaBoundaryModeTrap = 2
	CU_PARAM_TR_DEFAULT=-1
	CU_MEMORYTYPE_HOST = 0x01
	CU_MEMORYTYPE_DEVICE = 0x02
	CU_MEMORYTYPE_ARRAY = 0x03
	CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK = 1,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X = 2,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y = 3,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z = 4,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X = 5,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y = 6,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z = 7,
	CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK = 8,
	CU_DEVICE_ATTRIBUTE_SHARED_MEMORY_PER_BLOCK = 8,      // Deprecated, use CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK
	CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY = 9,
	CU_DEVICE_ATTRIBUTE_WARP_SIZE = 10,
	CU_DEVICE_ATTRIBUTE_MAX_PITCH = 11,
	CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK = 12,
	CU_DEVICE_ATTRIBUTE_REGISTERS_PER_BLOCK = 12,         // Deprecated, use CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK
	CU_DEVICE_ATTRIBUTE_CLOCK_RATE = 13,
	CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT = 14,
	CU_DEVICE_ATTRIBUTE_GPU_OVERLAP = 15,
	CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT = 16
	CU_LIMIT_STACK_SIZE        = 0x00
	CU_LIMIT_PRINTF_FIFO_SIZE  = 0x01
	CU_LIMIT_MALLOC_HEAP_SIZE  = 0x02
	CU_FUNC_ATTRIBUTE_MAX_THREADS_PER_BLOCK = 0,
	CU_FUNC_ATTRIBUTE_SHARED_SIZE_BYTES = 1,
	CU_FUNC_ATTRIBUTE_CONST_SIZE_BYTES = 2,
	CU_FUNC_ATTRIBUTE_LOCAL_SIZE_BYTES = 3,
	CU_FUNC_ATTRIBUTE_NUM_REGS = 4,
	CU_FUNC_ATTRIBUTE_PTX_VERSION = 5,
	CU_FUNC_ATTRIBUTE_BINARY_VERSION = 6,
	CU_GRAPHICS_REGISTER_FLAGS_NONE  = 0x00u
	CU_GRAPHICS_MAP_RESOURCE_FLAGS_NONE          = 0x00u
	CU_GRAPHICS_MAP_RESOURCE_FLAGS_READ_ONLY     = 0x01u
	CU_GRAPHICS_MAP_RESOURCE_FLAGS_WRITE_DISCARD = 0x02u
	CU_GRAPHICS_REGISTER_FLAGS_SURFACE_LDST = 0x04u

struct CUgraphicsResource_st
typedef CUgraphicsResource_st* CUgraphicsResource
struct cudaArray
struct cudaChannelFormatDesc
	int x;
	int y;
	int z;
	int w;
	int f;
struct cudaDeviceProp
	char[256] name
	size_t totalGlobalMem;
	size_t sharedMemPerBlock;
	int    regsPerBlock;
	int    warpSize;
	size_t memPitch;
	int    maxThreadsPerBlock;
	int[3]    maxThreadsDim;
	int[3]    maxGridSize;
	size_t totalConstMem;
	int    major;
	int    minor;
	int    clockRate;
	size_t textureAlignment;
//struct textureReference
//	int normalized
//	int filterMode
//	int[2] addressMode
//	cudaChannelFormatDesc  channelDesc;
struct dim3
	u32 x,y,z

const
	CUDA_SUCCESS                    = 0,
	CUDA_ERROR_INVALID_VALUE        = 1,
	CUDA_ERROR_OUT_OF_MEMORY        = 2,
	CUDA_ERROR_NOT_INITIALIZED      = 3,
	//
	CUDA_ERROR_NO_DEVICE            = 100,
	CUDA_ERROR_INVALID_DEVICE       = 101,
	//
	CUDA_ERROR_INVALID_IMAGE        = 200,
	CUDA_ERROR_INVALID_CONTEXT      = 201,
	CUDA_ERROR_CONTEXT_ALREADY_CURRENT = 202,
	CUDA_ERROR_MAP_FAILED           = 205,
	CUDA_ERROR_UNMAP_FAILED         = 206,
	CUDA_ERROR_ARRAY_IS_MAPPED      = 207,
	CUDA_ERROR_ALREADY_MAPPED       = 208,
	CUDA_ERROR_NO_BINARY_FOR_GPU    = 209,
	CUDA_ERROR_ALREADY_ACQUIRED     = 210,
	CUDA_ERROR_NOT_MAPPED           = 211,
	CUDA_ERROR_NOT_MAPPED_AS_ARRAY            = 212,
	CUDA_ERROR_NOT_MAPPED_AS_POINTER          = 213,
	CUDA_ERROR_ECC_UNCORRECTABLE              = 214,
	CUDA_ERROR_UNSUPPORTED_LIMIT              = 215,
	//
	CUDA_ERROR_INVALID_SOURCE       = 300,
	CUDA_ERROR_FILE_NOT_FOUND       = 301,
	//
	CUDA_ERROR_INVALID_HANDLE       = 400,
	//
	CUDA_ERROR_NOT_FOUND            = 500,
	//
	CUDA_ERROR_NOT_READY            = 600,
	//
	CUDA_ERROR_LAUNCH_FAILED        = 700,
	CUDA_ERROR_LAUNCH_OUT_OF_RESOURCES = 701,
	CUDA_ERROR_LAUNCH_TIMEOUT       = 702,
	CUDA_ERROR_LAUNCH_INCOMPATIBLE_TEXTURING = 703,
	//
	CUDA_ERROR_UNKNOWN              = 999
	CUDA_MY_ERROR_TOO_MANY_THREADS  = 100001
	//
	CU_JIT_MAX_REGISTERS            = 0,
	CU_JIT_THREADS_PER_BLOCK=1
	CU_JIT_WALL_TIME=2
	CU_JIT_INFO_LOG_BUFFER=3
	CU_JIT_INFO_LOG_BUFFER_SIZE_BYTES=4
	CU_JIT_ERROR_LOG_BUFFER=5
	CU_JIT_ERROR_LOG_BUFFER_SIZE_BYTES=6
	CU_JIT_OPTIMIZATION_LEVEL=7
	CU_JIT_TARGET_FROM_CUCONTEXT=8
	CU_JIT_TARGET=9
	CU_JIT_FALLBACK_STRATEGY=10
	CU_TARGET_COMPUTE_10=0
	CU_TARGET_COMPUTE_11=1
	CU_TARGET_COMPUTE_12=2
	CU_TARGET_COMPUTE_13=3
	//
	CU_CTX_SCHED_AUTO  = 0
	CU_CTX_SCHED_SPIN  = 1
	CU_CTX_SCHED_YIELD = 2
	CU_CTX_SCHED_MASK  = 0x3
	CU_CTX_BLOCKING_SYNC = 4
	CU_CTX_MAP_HOST = 8
	CU_CTX_FLAGS_MASK  = 0xf
	CU_MEMHOSTALLOC_PORTABLE        =0x01
	CU_MEMHOSTALLOC_DEVICEMAP       =0x02
	CU_MEMHOSTALLOC_WRITECOMBINED   =0x04
	CU_EVENT_DEFAULT       = 0
	CU_EVENT_BLOCKING_SYNC = 1

char* stdcall cudaGetErrorString(cudaError_t err)
	static sta
		char[256] ebuf
	switch err{
	default:
		write-sprintf(sta.ebuf;"unspecified driver error ",err)
		=sta.ebuf
	break;case 0:="no error";
	break;case 4:="driver call broken by user";
	break;case CUDA_ERROR_INVALID_VALUE:="invalid parameter value"
	break;case CUDA_ERROR_OUT_OF_MEMORY:="out of memory"
	break;case CUDA_ERROR_NOT_INITIALIZED:="not initialized"
	break;case CUDA_ERROR_NO_DEVICE:="no CUDA device"
	break;case CUDA_ERROR_INVALID_DEVICE:="invalid CUDA device"
	break;case CUDA_ERROR_LAUNCH_FAILED:="kernel crashed"
	break;case CUDA_ERROR_LAUNCH_OUT_OF_RESOURCES:="not enough resources for kernels"
	break;case CUDA_ERROR_LAUNCH_TIMEOUT:="kernel timeout and terminated"
	break;case CUDA_ERROR_LAUNCH_INCOMPATIBLE_TEXTURING:="incompatible texturing"
	break;case CUDA_ERROR_MAP_FAILED:="map failed"
	break;case CUDA_ERROR_UNMAP_FAILED:="unmap failed"
	break;case CUDA_ERROR_ALREADY_MAPPED:="already mapped"
	break;case CUDA_ERROR_INVALID_HANDLE:="invalid handle"
	break;case CUDA_ERROR_INVALID_CONTEXT:="GPU used in a wrong thread"
	break;case CUDA_ERROR_UNKNOWN:="kernel crashed? (unknown error)"
	break;case CUDA_ERROR_ECC_UNCORRECTABLE:="GPU memory failure, !!YOUR GPU COULD BE BURNING!!"
	break;case CUDA_MY_ERROR_TOO_MANY_THREADS:="more threads are required than CUDA can handle, please add spapTargetOption('cudaLaunchMethod','$$cuda.cudevBigLoop'); to your parallel loops"
	break;case CUDA_ERROR_INVALID_IMAGE:
		="a mismatch between your CUDA Toolkit, the 32-bit SPAP compiler, or your driver is detected. Are you using a CUDA 3.0+ compiler with a pre-3.0 driver?"
	}

with $$cuda
	int lasterror=CUDA_SUCCESS
	char* error
		get()
			err=cuda.lasterror
			return cudaGetErrorString(err)
	int currentdevice
		%get()=spapGetCurrentCoreId()

%int cuCtxSynchronize()
	return spapFinish()

%int cudaThreadSynchronize()
	return spapFinish()

//emulate old memory system
with detail
	const
		GL_USE_PERMANENT=(meta.output_target==meta.OUTPUT_C?
			!!compiler.getcmdlineoption("gl_usepermanent"):
			!compiler.getcmdlineoption("gl_nopermanent"))
	__define__ NODLIST "using meta;OnMatch(pf){\
		if thasmember(b.t)&&findmember(b.t,getid('__is_dlist')):\
			Match.reject;\
		if thasmember(a.t)&&findmember(a.t,getid('__is_dlist')):\
			Match.reject;\
		Match.standard;\
	}"

struct CUDA_ARRAY_DESCRIPTOR
	int Width;
	int Height;
	int Format;
	int NumChannels;
struct CUDA_ARRAY3D_DESCRIPTOR
    int Width;
    int Height;
    int Depth;
    int Format;
    int NumChannels;
    int Flags;
struct CUarray_t
struct CUsurfref_t
struct CUtexref_t
struct CUstream_st
struct CUevent_st
typedef void* CUdeviceptr
typedef CUarray_t* CUarray
typedef CUtexref_t* CUtexref
typedef CUsurfref_t* CUsurfref
typedef int CUdevice
typedef void* CUcontext
typedef CUstream_st *CUstream;
typedef CUevent_st *CUevent;
struct CUDA_MEMCPY2D
	int srcXInBytes, srcY;
	int srcMemoryType;
	void* srcHost;
	CUdeviceptr srcDevice;
	CUarray srcArray;
	int srcPitch;
	int dstXInBytes, dstY;
	int dstMemoryType;
	void *dstHost;
	CUdeviceptr dstDevice;
	CUarray dstArray;
	int dstPitch
	int WidthInBytes;
	int Height;
struct CUDA_MEMCPY3D
	int srcXInBytes, srcY, srcZ;
	int srcLOD;
	int srcMemoryType;
	void *srcHost;
	CUdeviceptr srcDevice;
	CUarray srcArray;
	int reserved0;
	int srcPitch;  // ignored when src is array
	int srcHeight; // ignored when src is array; may be 0 if Depth==1

	int dstXInBytes, dstY, dstZ;
	int dstLOD;
	int dstMemoryType;
	void *dstHost;
	CUdeviceptr dstDevice;
	CUarray dstArray;
	int reserved1;
	int dstPitch;  // ignored when dst is array
	int dstHeight; // ignored when dst is array; may be 0 if Depth==1

	int WidthInBytes;
	int Height;
	int Depth;
struct CUdevprop
	int maxThreadsPerBlock;
	int[3] maxThreadsDim;
	int[3] maxGridSize;
	int sharedMemPerBlock;
	int totalConstantMemory;
	int SIMDWidth;
	int memPitch;
	int regsPerBlock;
	int clockRate;
	int textureAlign;

with detail{
#def GPULIB_IMPORT:
	using meta
	wantstr()
	skip(int'{')
	imps=new cvec(tsymbol)
	emitcode_begin()
	while !want(int'}')
		isstdcall=0
		t=atype()
		if wantid(getid('stdcall')):isstdcall=1
		id=wantid()
		pp=prototype_1()
		tf=makefunctype(isstdcall?cfunction.cv_stdcall:cfunction.cv_cdecl,t,pp,0)
		write-emitcodef('meta.typefromiptr(',tf,') _impl_',id.s,'=NULL;')
		write-emitcodef('with $$cubsgp{__define__ ',id.s,
			' "$$cubsgp.detail._impl_',id.s,'";}')
		if isstdcall:
			tf0=makefunctype(cfunction.cv_cdecl,t,pp,0)
			write-emitcodef('meta.typefromiptr(',tf0,') _impl_cdecl_',id.s,'=NULL;')
			write-emitcodef('meta.typefromiptr(',t,') stdcall _c2s_',id.s,'(')
			for i=0:pp.n-1
				ta=pp.d[i].t
				if i:write-emitcodef(',')
				write-emitcodef('meta.typefromiptr(',ta,') p',i)
			write-emitcodef('){return ._impl_cdecl_',id.s,'(')
			for i=0:pp.n-1
				if i:write-emitcodef(',')
				write-emitcodef('p',i)
			write-emitcodef(')}')
		imps.add(id)
		while want(int';'):;
	write-emitcodef("void do_import(){__IS_CUDA_CDECL=(iptr)spapGetGpuApi('__IS_CUDA_CDECL');")
	write-emitcodef("if !__IS_CUDA_CDECL:{")
	for i=0:imps.n-1
		write-emitcodef('._impl_',imps[i].s,'=(void*)spapGetGpuApi("',imps[i].s,'");')
	write-emitcodef("}else{")
	for i=0:imps.n-1
		write-emitcodef('pfunc=(void*)spapGetGpuApi("',imps[i].s,'");')
		write-emitcodef('._impl_cdecl_',imps[i].s,'=pfunc;if pfunc:','._impl_',imps[i].s,'=_c2s_',imps[i].s,';')
	write-emitcodef("}}")
	emitcode_end()
typedef void IDirect3DDevice9
typedef void IDirect3DVertexBuffer9
If compiler.getcmdlineoption("CUBSGP_NO_GL"):
	typedef int GLuint
	typedef int GLenum
GPULIB_IMPORT "nvcuda.dll"
	int stdcall cuDriverGetVersion(int* driverVersion)
	int stdcall cuTexRefSetArray( CUtexref hTexRef, CUarray hArray, int Flags );
	int stdcall cuTexRefSetAddress( int *ByteOffset, CUtexref hTexRef, CUdeviceptr dptr, int bytes );
	int stdcall cuTexRefSetAddress2D( CUtexref hTexRef, CUDA_ARRAY_DESCRIPTOR *desc, CUdeviceptr dptr, int Pitch);
	int stdcall cuTexRefSetFormat( CUtexref hTexRef, int fmt, int NumPackedComponents );
	int stdcall cuTexRefSetAddressMode( CUtexref hTexRef, int dim, int am );
	int stdcall cuTexRefSetFilterMode( CUtexref hTexRef, int fm );
	int stdcall cuTexRefSetFlags( CUtexref hTexRef, int Flags );
	int stdcall cuSurfRefSetArray( CUsurfref hSurfRef, CUarray hArray, int Flags );
	int stdcall cuSurfRefGetArray( CUarray *phArray, CUsurfref hSurfRef );
	int stdcall cuArrayCreate( CUarray *pHandle, CUDA_ARRAY_DESCRIPTOR *pAllocateArray );
	int stdcall cuArray3DCreate( CUarray *pHandle, CUDA_ARRAY3D_DESCRIPTOR *pAllocateArray );
	int stdcall cuArrayGetDescriptor( CUDA_ARRAY_DESCRIPTOR *pArrayDescriptor, CUarray hArray );
	int stdcall cuArray3DGetDescriptor( CUDA_ARRAY3D_DESCRIPTOR *pArrayDescriptor, CUarray hArray );
	int stdcall cuArrayDestroy( CUarray hArray );
	int stdcall cuMemcpy2D( CUDA_MEMCPY2D *pCopy );
	int stdcall cuMemcpy2DUnaligned( CUDA_MEMCPY2D *pCopy );
	int stdcall cuMemcpy3D( CUDA_MEMCPY3D *pCopy );
	int stdcall cuMemsetD8( CUdeviceptr dstDevice,  char uc,  int N )
	int stdcall cuMemsetD32( CUdeviceptr dstDevice,  int ui,  int N )
	int stdcall cuGLInit();
	int stdcall cuGLRegisterBufferObject( u32 bufferobj );
	int stdcall cuGLMapBufferObject( CUdeviceptr *dptr, int *size,  u32 bufferobj );
	int stdcall cuGLUnmapBufferObject( u32 bufferobj );
	int stdcall cuGLUnregisterBufferObject( u32 bufferobj );
	int stdcall cuMemGetInfo(iptr* free, iptr* total)
	int stdcall cuCtxSetLimit(int limit, iptr value)
	int stdcall cuCtxGetLimit(iptr *pvalue, int limit)
	int stdcall cuFuncGetAttribute(int *pi, int attrib, void* hfunc)
	int stdcall cuGraphicsGLRegisterImage(CUgraphicsResource* pCudaResource,GLuint image,GLenum target,u32 Flags)
	int stdcall cuGraphicsMapResources(u32 count,CUgraphicsResource* resources,CUstream hStream)
	int stdcall cuGraphicsSubResourceGetMappedArray(CUarray* pArray,CUgraphicsResource resource,u32 arrayIndex,u32 mipLevel)
	int stdcall cuGraphicsUnmapResources(u32 count,CUgraphicsResource* resources,CUstream hStream)
	int stdcall cuGraphicsUnregisterResource(CUgraphicsResource resource)
	int stdcall cuMemAllocHost(void **pp, int bytesize)

%void* getCudaModule()=spap.detail.getCudaModule()
}

If compiler.getcmdlineoption("force_checkpoint"):
	void checkpoint_error(char* s)
		fi=fopen("CONIN$","rb");
		fo=fopen("CONOUT$","wb");
		(void()()spapGetGpuApi("cudaDumpBlocks"))()
		write(fo,s,' ',cuda.error,' ')
		fflush(fo)
		readln(fi)
		fclose(fo)
		fclose(fi)
		DebugBreak()
	void checkpoint(char* s)
		er=cuda.lasterror
		if er==CUDA_SUCCESS:
			cuda.lasterror=cuCtxSynchronize()
			er=cuda.lasterror
		if er!=CUDA_SUCCESS:
			checkpoint_error(s)
	/meta.state('metaf-checkpoint')=(void*)meta.hasmethod($$cubsgp,checkpoint(char*))
Else
	void checkpoint(char* s){}
	void checkpoint_error(char* s){}

with detail{
%mylazyinit()
	spap.detail.lazyinit()
	if !cuTexRefSetArray:do_import()
}

%void* allocd(iptr sz)
	mylazyinit()
	=spapAllocd(sz)
%void freed(void* p)
	Compile
		using meta;
		OnMatch(pf)
			if thasmember(p.t)&&findmember(p.t,getid('__is_dlist')):
				Match.reject;
			Match.standard;
	spapFreed(p)
%void* reallocd(void* p,iptr sz)=spapReallocd(p,sz)
%int cpyh2d(void* a,void* b,iptr sz)
	Compile{detail.NODLIST;}
	er=spapCpyh2d(a,b,sz);
	$$cuda.lasterror=er
	checkpoint("cpyh2d")
	return er

%int cpyd2h(void* a,void* b,iptr sz)
	Compile{detail.NODLIST;}
	er=spapCpyd2h(a,b,sz);
	$$cuda.lasterror=er
	checkpoint("cpyd2h")
	return er

%int cpyd2d(void* a,void* b,iptr sz)
	Compile{detail.NODLIST;}
	er=spapCpyd2d(a,b,sz);
	$$cuda.lasterror=er
	checkpoint("cpyd2d")
	return er

//emulate old intrinsics
inline selp(a,b,int c)
	return c?a:b

//emulate old keywords
#def dnew:
	using meta
	//copied from compiler
	arrayed=0
	e=&makeeri(1);
	if want(int'['):
		e=&assexpr();
		skip(int']');
		arrayed=1;
	if !arrayed:
		t=atype0()
		t=typemodifiers_new(t,&arrayed,e)
	else
		t=atype()
	if tisint(e.t):
		castto(e,t0_iptr)
	else
		reject_dhook(e)
		write-errorf("dnew's array size has to be integer, not ",dumptype(e.t))
	if !arrayed:
		if tis(t,ctype.array):
			arrayed=1
			e=&makeeri(((ctype*)t).sz)
			t=((ctype*)t).t0
	if tisclass(t):error("can't new class in device")
	e2=&makeeri(_sizeof(t));
	feedexpr(castto(&call('$$cubsgp.allocd',List[&call('operator*',List[e,e2])]),makeptrtype(t)))

#def ddelete:
	using meta
	feedexpr(&call('$$cubsgp.freed',List[&assexpr()]))

///////////////////////////////////////////
//tex
class CCUDATextureCore
	//arrays can be pseudo CSPAPBuffers
	void* pdata
	iptr sz
	char* name
	int isarray
	int fm,nc
	int[3] addressMode
	int filterMode
	int flags
	int ndim
	int3 dims
	novirtual %__init__()
		mylazyinit()
	novirtual %void resize(int ndim,int3 dims)
		.pdata=NULL
		.sz=0
		.isarray=0
		.ndim=ndim
		.dims=dims
	novirtual %int bindAddrRange(iptr* ofs,void* p,iptr sz)
		if .ndim!=1:return CUDA_ERROR_INVALID_VALUE
		pa=(iptr)p&~255
		if ofs:*ofs=(iptr)p-pa
		.pdata=(void*)pa
		.sz=sz+((iptr)p-pa)
		.isarray=0
		return CUDA_SUCCESS
	novirtual %int bind2D(void* p,iptr sz)
		if .ndim!=2:return CUDA_ERROR_INVALID_VALUE
		.pdata=p
		.sz=sz
		.isarray=0
		return CUDA_SUCCESS
	novirtual %int bindArray(CUarray pb)
		.pdata=pb
		.sz=-1
		.isarray=1
		return CUDA_SUCCESS
	novirtual %void cudaBind(int tid)
		if !.pdata:
			if .name:
				serr=write-strprintf("texture ",.name," is used before binding")
				checkpoint_error((char*)serr)
		texref=spapGetTextureHandle(getCudaModule(),tid)
		cuTexRefSetFormat(texref,.fm,.nc)
		cuTexRefSetFlags(texref,.flags)
		//writeln(texref,' ',er0,' ',er1,' ',.fm,' ',.nc)
		if .isarray:
			cuTexRefSetArray(texref,.pdata,0)
			for i=0:.ndim-1
				cuTexRefSetAddressMode(texref,i,.addressMode[i])
			cuTexRefSetFilterMode(texref,.filterMode)
		else
			if .ndim==1:
				cuTexRefSetAddress(&0,texref,.pdata,.sz);
				//writeln((void*)texref,' ',.fm,' ',.nc,' ',void*(.pdata),' ',.sz,' ',er)
			elif .ndim==2:
				with CUDA_ARRAY_DESCRIPTOR ad
					.Width=..dims[0]
					.Height=..dims[1]
					.Format=..fm
					.NumChannels=..nc
				cuTexRefSetAddress2D(texref,&ad,.pdata,.sz)
				for i=0:.ndim-1
					cuTexRefSetAddressMode(texref,i,.addressMode[i])
				cuTexRefSetFilterMode(texref,.filterMode)
			else
				assert(0)
	__operation__ uint4 ifetch(int a)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(uint4),"@returnto",(uint4*)result,
					"=tex1Dfetch(*(texture<uint4,1,cudaReadModeElementType>*)&__tex","@const",tid,
					",",a,");")
				...
	__operation__ float4 ffetch(int a)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(float4),"@returnto",result,
					"=tex1Dfetch(*(texture<float4,1,cudaReadModeElementType>*)&__tex","@const",tid,
					",",a,");")
				...
	__operation__ float4 ffetch2D(float u,float v)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(float4),"@returnto",(float4*)result,
					"=tex2D(*(texture<float4,2,cudaReadModeElementType>*)&__tex","@const",tid,
					",",u,",",v,");")
				...
	__operation__ uint4 ifetch2D(float u,float v)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(uint4),"@returnto",(uint4*)result,
					"=tex2D(*(texture<uint4,2,cudaReadModeElementType>*)&__tex","@const",tid,
					",",u,",",v,");")
				...
	__operation__ float4 ffetch3D(float u,float v,float w)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(float4),"@returnto",(float4*)result,
					"=tex3D(*(texture<float4,3,cudaReadModeElementType>*)&__tex","@const",tid,
					",",u,",",v,",",w,");")
				...
	__operation__ uint4 ifetch3D(float u,float v,float w)
		case "CUDA"
			tid=spapAllocateTexture()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@return",meta.typeid(uint4),"@returnto",(uint4*)result,
					"=tex3D(*(texture<uint4,3,cudaReadModeElementType>*)&__tex","@const",tid,
					",",u,",",v,",",w,");")
				...

with detail{
using meta
int type2cuad(iptr t0)
	fm=-1
	switch t0{
	default:error("unsupported texture type");
	break;case t0_u8:fm=CU_AD_FORMAT_UNSIGNED_INT8
	break;case t0_u16:fm=CU_AD_FORMAT_UNSIGNED_INT16
	break;case t0_u32:fm=CU_AD_FORMAT_UNSIGNED_INT32
	break;case t0_i8:fm=CU_AD_FORMAT_SIGNED_INT8
	break;case t0_i16:fm=CU_AD_FORMAT_SIGNED_INT16
	break;case t0_i32:fm=CU_AD_FORMAT_SIGNED_INT32
	break;case typeid(half):fm=CU_AD_FORMAT_HALF
	break;case t0_f32:fm=CU_AD_FORMAT_FLOAT
	}
	return fm;
int getszfm(int fm)
	switch fm{
	default:return 0
	break;case CU_AD_FORMAT_UNSIGNED_INT8:return 1
	break;case CU_AD_FORMAT_UNSIGNED_INT16:return 2
	break;case CU_AD_FORMAT_UNSIGNED_INT32:return 4
	break;case CU_AD_FORMAT_SIGNED_INT8:return 1
	break;case CU_AD_FORMAT_SIGNED_INT16:return 2
	break;case CU_AD_FORMAT_SIGNED_INT32:return 4
	break;case CU_AD_FORMAT_HALF:return 2
	break;case CU_AD_FORMAT_FLOAT:return 4
	}
	return 0;
ntex=/0
struct _texture(Tid,Tfetch,Tbind,Telement,Tndim,const varname)//Tid as char[texunit id+1]
	//sizeof Tid-1 == sizeof Tid(-1)
	const{texid=sizeof(Tid)-1;ndim=sizeof Tndim;fmelement=type2cuad(typeid(Telement))}
	const
		default_fm=type2cuad(typeid(Telement))
		default_nc=sizeof(Tndim)
	static{
	tls_thetex=TlsAlloc()
	CCUDATextureCore* thetex
		__host__ CCUDATextureCore* get()
			ret=(CCUDATextureCore*)TlsGetValue(.tls_thetex)
			if !ret:
				retx=new CCUDATextureCore
				retx._addref()
				ret=retx
				TlsSetValue(.tls_thetex,ret)
				ret.resize(1,make_int3(0,0,0))
				ret.fm=default_fm
				ret.nc=default_nc
				ret.flags=0
				/
					using meta
					emitcode_begin()
					write-emitcodef("ret.name=")
					emitcode_str((char*)varname)
					write-emitcodef(";")
					emitcode_end()
				If thasmember(typeid(Tfetch)):
					typedef Tfetch.Telement Telementf
				Else
					typedef Tfetch Telementf
				If Telementf==Telement:
					ret.flags|=1
			return ret
		__precompute__ CCUDATextureCore* get()
			require
				ret=.thetex
			return ret
	}
	%bind(iptr* ofs,void* r,iptr sz)
		return .thetex.bindAddrRange(ofs,r,sz);
	%bind(void* p)
		Compile
			OnMatch(me,her)
				if her.as[0]==typeid(CUarray):
					Match.reject
				if thasmember(her.as[0])&&findmember(her.as[0],getid('__is_dlist')):
					Match.reject;
				Match.standard
		assert(!((iptr)p&255))
		return .thetex.bindAddrRange(null,p,0x08000000*(sizeof(Telement)*ndim))
	%bind(dlist(Tbind)* p)
		.bind(null,p.d,p.n*sizeof(Tbind))
	%bind(CUarray a)
		Compile
			OnMatch(me,her)
				if her.as[0]==typeid(void*):
					Match.reject
				Match.standard
		return .thetex.bindArray(a)
	%bind(CUarray a,int flag)
		return .thetex.bindArray(a)
	%bind2D(void* p,int w,int h,iptr pitch)
		.thetex.resize(2,make_int3(w,h,0))
		return .thetex.bind2D(p,pitch)
	%bind2D(void* p,int w,int h)
		=.bind2D(p,w,h,w*(sizeof(Telement)*ndim))
	Tbind* address
		__host__ %get()
			return (Tbind*)(.thetex.pdata)
		__host__ %set(Tbind* r)
			.bind(null,r,0x08000000*(sizeof(Telement)*ndim))
	CUarray array
		__host__ %get()
			return CUarray(.thetex.pdata)
		__host__ %set(CUarray a).bind(a)
	struct ctypehlp
		int fm,nc
	ctypehlp _type
		%set(ctypehlp a)
			.thetex.fm=a.fm
			.thetex.nc=a.nc
		%ctypehlp get()
			with result
				.fm=..thetex.fm
				.nc=..thetex.nc
	int readmode
		%get()
			return .thetex.flags&CU_TRSF_READ_AS_INTEGER
		%set(int rm)
			.thetex.flags=(.thetex.flags&~CU_TRSF_READ_AS_INTEGER)|!!rm
	struct caddrmodehlp
		CCUDATextureCore* thetex
		struct caddrmodehlp2
			CCUDATextureCore* thetex
			int dim
			int __auto__
				%get()
					return .thetex.addressMode[.dim]
				%set(int a)
					.thetex.addressMode[.dim]=a
		%caddrmodehlp2 operator[](const a)
			If a<0||a>2:error("address mode only has 3 dimensions")
			with result
				.thetex=..thetex
				.dim=a
	caddrmodehlp addressMode
		%caddrmodehlp get()
			with result
				.thetex=..thetex
	int filterMode
		%get()=.thetex.filterMode
		%set(int d)
			.thetex.filterMode=d
	int normalized
		%get()
			return .thetex.flags&CU_TRSF_NORMALIZED_COORDINATES
		%set(int rm)
			.thetex.flags=(.thetex.flags&~CU_TRSF_NORMALIZED_COORDINATES)|CU_TRSF_NORMALIZED_COORDINATES*!!rm
	__device__ loadas(class Tfetch,int d)
		Tfetch result
		If thasmember(typeid(Tfetch)):
			typedef Tfetch.Telement Telement
		Else
			/meta.curfunc.flags&=~meta.cfunc.trait_prelive
			typedef Tfetch Telement
		If Telement==f32:
			rr=.thetex.ffetch(d)
		Else
			rr=.thetex.ifetch(d)
		If !thasmember(typeid(Tfetch)):
			return (Telement)rr[0]
		Else
			with result
				.x=(Telement)rr[0]
				If Tfetch.ndim>1:.y=(Telement)rr[1]
				If Tfetch.ndim>2:.z=(Telement)rr[2]
				If Tfetch.ndim>3:.w=(Telement)rr[3]
	__device__ Tfetch load(int d)=.loadas(Tfetch,d)
	__device__ Tfetch operator[](int d)=.load(d)
	__device__ load2Das(class Tfetch,float u,float v)
		Tfetch result
		If thasmember(typeid(Tfetch)):
			typedef Tfetch.Telement Telement
		Else
			/meta.curfunc.flags&=~meta.cfunc.trait_prelive
			typedef Tfetch Telement
		If Telement==f32:
			rr=.thetex.ffetch2D(u,v)
		Else
			rr=.thetex.ifetch2D(u,v)
		If Telement==f32:
			r=*(float4*)&rr
		Else
			r=rr
		If !thasmember(typeid(Tfetch)):
			return (Telement)r[0]
		Else
			with result
				.x=(Telement)r[0]
				If Tfetch.ndim>1:.y=(Telement)r[1]
				If Tfetch.ndim>2:.z=(Telement)r[2]
				If Tfetch.ndim>3:.w=(Telement)r[3]
	__device__ Tfetch load2D(float u,float v)=.load2Das(Tfetch,u,v)
	__device__ load3Das(class Tfetch,float u,float v,float w)
		Tfetch result
		If thasmember(typeid(Tfetch)):
			typedef Tfetch.Telement Telement
		Else
			/meta.curfunc.flags&=~meta.cfunc.trait_prelive
			typedef Tfetch Telement
		If Telement==f32:
			rr=.thetex.ffetch3D(u,v,w)
		Else
			rr=.thetex.ifetch3D(u,v,w)
		If Telement==f32:
			r=*(float4*)&rr
		Else
			r=rr
		If !thasmember(typeid(Tfetch)):
			return (Telement)r[0]
		Else
			with result
				.x=(Telement)r[0]
				If Tfetch.ndim>1:.y=(Telement)r[1]
				If Tfetch.ndim>2:.z=(Telement)r[2]
				If Tfetch.ndim>3:.w=(Telement)r[3]
	__device__ Tfetch load3D(float u,float v,float w)=.load3Das(Tfetch,u,v,w)
	__host__ inline void settype(class T)
		/
			char[512] ebuf
			ttype t0
			t=typeid(T)
			if !isptr(t):
				t0=t
				nc=1
			else
				if !thasmember(t)||!findmember(t,getid('Telement')):
					write-errorf('invalid texture type ',dumptype(t))
				write-sprintf(ebuf;"$$system.meta.typeid($$system.meta.typefromiptr(",t,").Telement)")
				eval(ebuf,t0_iptr,&t0)
				write-sprintf(ebuf;"($$system.meta.typefromiptr(",t,")).ndim")
				eval(ebuf,t0_i32,&nc)
			fm=type2cuad(t0)
			emitcode_begin()
			write-emitcodef('.thetex.fm=',fm,';.thetex.nc=',nc,';')
			emitcode_end()
}
#def texture:
	//note: texture id is encoded in the TYPE, not the OBJECT
	using meta
	psd=meta.curstruct
	if meta.idmode==tranid_decl&&psd&&psd.mode!=kw_static:
		warning("texture is always static, even as member")
	if meta.idmode!=tranid_decl&&meta.W(3):
		warning("texture is always static, even as local variable")
	char[512] ebuf
	tid=detail.ntex++
	fm=CU_AD_FORMAT_UNSIGNED_INT32;nc=1;rm=cudaReadModeElementType
	t=t0_i32
	if want(int'(')||want(int'<'):
		t=atype()
		iptr t0
		if !isptr(t):
			t0=t
			nc=1
		else
			write-sprintf(ebuf;"$$system.meta.typeid($$system.meta.typefromiptr(",t,").Telement)")
			eval(ebuf,t0_iptr,&t0)
			write-sprintf(ebuf;"($$system.meta.typefromiptr(",t,")).ndim")
			eval(ebuf,t0_i32,&nc)
		fm=type2cuad(t0)
		if want(int','):cnsexpr()//skip dimension
		if want(int','):rm=cnsexpr()//read mode
		if !want(int'>'):skip(int')')
	id=wantid()
	varname=*char**id
	tbind=t
	if rm==cudaReadModeNormalizedFloat:
		//change Tfetch to float vector
		write-sprintf(ebuf;"$$system.meta.typeid(float",char(nc==1?int(' '):(nc+'0')),")")
		eval(ebuf,t0_iptr,&t)
		//t0=t0_f32
	char[384] tname
	write-sprintf(tname;"$$cubsgp.detail._texture(char[",tid+1,"],\
$$system.meta.typefromiptr(",t,"),$$system.meta.typefromiptr(",tbind,"),\
$$system.meta.typefromiptr(",t0,"),char[",nc,"],",(iptr)varname,")")
	//write-sprintf(ebuf;"$$system.meta.typeid(",tname,") ")
	//eval(ebuf,t0_iptr,&iptr ttex)
	//detail.texini.back().tt=ttex
	emitcode_clear()
	if meta.idmode==tranid_decl:
		emitcode("{")
	emitcode(tname);write-emitcodef(;" ",*char**id)
	if meta.idmode==tranid_decl:
		emitcode("}")
	emitcode_flush()

with dlist
	If spap.detail.tisdlistsimple(meta.typeid(T)):{struct{
	using meta
	#version 1
	If T==double4:{
	__operation__ T __loadold(int a)
		case "CUDA"
			mylazyinit()
			d=(T*)(.getDevicePointer())
			spawn ...
				...
				result=d[a]
				...
	}Else{
	__operation__ T __loadold(int a)
		case "CUDA"
			mylazyinit()
			tid=spapAllocateTexture()
			texref=spapGetTextureHandle(getCudaModule(),tid)
			If T==double||T==i64||T==u64:
				typedef uint2 Tfetch
			Elif T==double2||T==long2||T==ulong2:
				typedef uint4 Tfetch
			Else
				If tisiptrcastable(typeid(T)):
					typedef iptr Tfetch
				Else
					typedef T Tfetch
			If tisiptrcastable(typeid(Tfetch)):
				typedef Tfetch Telement
				const
					ndim=1
			Elif thasmember(typeid(Tfetch)):
				typedef Tfetch.Telement Telement
				const
					ndim=Tfetch.ndim
			Else
				typedef Tfetch Telement
				const
					ndim=1
			const
				cufmid=type2cuad(typeid(Telement))
			cuTexRefSetFormat(texref,cufmid,ndim)
			cuTexRefSetFlags(texref,CU_TRSF_READ_AS_INTEGER)
			cuTexRefSetAddress(&0,texref,.getDevicePointer(),0x08000000*sizeof(T));
			spawn ...
				...
				If T==Tfetch:
					If tisprimitive(typeid(T)):
						result=__asm__("@return",meta.typeid(T),
							"=tex1Dfetch(*(texture<","@type",T,",1,cudaReadModeElementType>*)&__tex","@const",tid,
							",",a,");")
					Else
						__asm__("@return",meta.typeid(T),"@returnto",(T*)&result,
							"=tex1Dfetch(*(texture<","@type",T,",1,cudaReadModeElementType>*)&__tex","@const",tid,
							",",a,");")
				Else
					If tisprimitive(typeid(Tfetch)):
						r=__asm__("@return",meta.typeid(Tfetch),
							"=tex1Dfetch(*(texture<","@type",Tfetch,",1,cudaReadModeElementType>*)&__tex","@const",tid,
							",",a,");")
					Else
						Tfetch r
						__asm__("@return",meta.typeid(Tfetch),"@returnto",&r,
							"=tex1Dfetch(*(texture<","@type",Tfetch,",1,cudaReadModeElementType>*)&__tex","@const",tid,
							",",a,");")
					If tisiptrcastable(typeid(T)):
						r2=r
					Elif Tfetch==uint2:
						r2=((u64)r.y<<32)+(u64)r.x
					Else
						r2=make_ulong2(
							((u64)r.y<<32)+(u64)r.x,
							((u64)r.w<<32)+(u64)r.z)
					result[=]*(T*)&r2
				...
	}
	#version 0
	}}

__device__ tex1Dfetch(tex,int x)=tex.load(x)
__device__ tex1D(tex,float u)=tex.load2D(u,0.5f)
__device__ tex2D(tex,float u,float v)=tex.load2D(u,v)
__device__ tex3D(tex,float u,float v,float w)=tex.load3D(u,v,w)

/////////////////////////////////////////////
//surface
class CCUDASurface
	CUarray array
	novirtual %__init__()
		mylazyinit()
	novirtual %int bindArray(CUarray pb)
		.array=pb
		return CUDA_SUCCESS
	novirtual %void cudaBind(int surfid)
		if !.array:
			serr=write-strprintf("surface ",this," is used before binding")
			checkpoint_error((char*)serr)
		surfref=spapGetSurfaceHandle(getCudaModule(),surfid)
		ret=cuSurfRefSetArray(surfref,.array,0)
		//CUarray ar=NULL
		//cuSurfRefGetArray(&ar,surfref)
		//writeln(ar)
		$$cuda.lasterror=ret;
		checkpoint("cuSurfSetArray");
	__operation__ surf2Dread(class T,int x,int y)
		case "CUDA"
			tid=spapAllocateSurface()
			.cudaBind(tid)
			#version 1
			T result
			T ret
			spawn ...
				...
				__asm__("@prelive","surf2Dread(",&ret,",__surf","@const",tid,
					",",x,",",y,");")
				result=ret
				...
			#version 0
	__operation__ surf2Dwrite(val,int x,int y)
		case "CUDA"
			typedef typeof(val) T
			tid=spapAllocateSurface()
			.cudaBind(tid)
			spawn ...
				...
				__asm__("@prelive","surf2Dwrite(",val,",__surf","@const",tid,
					",",x,",",y,");")
				...

class CSurface(T):CCUDASurface
	If !spap.detail.tisdlistsimple(meta.typeid(T)):
		/error("CSurface is only supported for basic types and 2D/4D vectors")
	typedef CSurface(T)* PMyType
	If meta.tiscomplicated(meta.typeid(T)):
		const
			NDIM=T.ndim
	Else
		const
			NDIM=1
	struct TBraHelper
		PMyType ptr
		int x,y
		T __auto__
			__device__ inline T get()
				return .ptr.surf2Dread(T,.x*sizeof(T),.y)
			__device__ inline void set(T a)
				.ptr.surf2Dwrite(a,.x*sizeof(T),.y)
	__device__ TBraHelper operator()(int x,int y)
		with result
			.ptr=this
			.x=x
			.y=y

/////////////////////////////////////////////
//arrays
with detail{
void* newArray(int fm,int nc,int ndim,int* dims,int flags)
	if ndim==2:{
		CUDA_ARRAY_DESCRIPTOR cd
		memset(&cd,0,sizeof(cd))
		with cd
			.Width=dims[0]
			.Height=dims[1]
			.Format=fm
			.NumChannels=nc
		ret=(CUarray)NULL
		cuArrayCreate(&ret,&cd)
		return ret
	}
	if ndim==3:{
		CUDA_ARRAY3D_DESCRIPTOR cd
		memset(&cd,0,sizeof(cd))
		with cd
			.Width=dims[0]
			.Height=dims[1]
			.Depth=dims[2]
			.Format=fm
			.NumChannels=nc
			.Flags=flags
		ret=CUarray NULL
		cuArray3DCreate(&ret,&cd)
		return ret
	}
	return NULL
int delArray(void* p)
	return cuArrayDestroy(p)
CUarray _danew(int w,int h,int fm,int nc)
	mylazyinit()
	dims=make_int2(w,h)
	return newArray(fm,nc,2,&dims[0],0)
CUarray _danew3D(int w,int h,int z,int fm,int nc,flags)
	mylazyinit()
	dims=make_int3(w,h,z)
	return newArray(fm,nc,3,&dims[0],flags)
}
#def danew:
	using meta
	//copied from compiler
	flags=0
	t=atype()
	skip(int'(')
	ea0=&assexpr();
	skip(int',');
	ea1=&assexpr();
	if want(int','):
		if !got(tok_str):
			ea3d=&assexpr();
		else
			unlex(int',')
			ea3d=&makeeri(0)
	else
		ea3d=NULL
	if want(int','):
		if got(tok_str):
			s=wantstr()
			if strstr(s,"surface"):
				flags|=CUDA_ARRAY3D_SURFACE_LDST
			//if ea3d&&ea3d.iscns()&&ea3d.t==t0_iptr&&ea3d.c.ciptr<1:
			//	flags|=CUDA_ARRAY3D_2DARRAY
		else
			flags=cnsexpr()
	skip(int')');
	iptr te
	int ndim
	if isptr(t):
		char[260] ebuf
		write-sprintf(ebuf;"$$system.meta.typeid($$system.meta.typefromiptr(",t,").Telement)")
		eval(ebuf,t0_iptr,&te)
		write-sprintf(ebuf;"($$system.meta.typefromiptr(",t,")).ndim")
		eval(ebuf,t0_i32,&ndim)
	else
		te=t
		ndim=1
	ea2=&makeeri(type2cuad(te))
	ea3=&makeeri(ndim)
	eaflag=&makeeri(flags)
	if ea3d:
		er=&call('$$cubsgp.detail._danew3D',List[ea0,ea1,ea3d,ea2,ea3,eaflag]);
	else
		er=&call('$$cubsgp.detail._danew',List[ea0,ea1,ea2,ea3]);
	feedexpr(er)
#def dadelete:
	using meta
	e=&assexpr();
	feedexpr(&call('$$cubsgp.detail.delArray',List[e]))
cpyh2a(CUarray a,void* h)
	ret=cuArray3DGetDescriptor(&CUDA_ARRAY3D_DESCRIPTOR cd3d,a)
	if ret!=CUDA_SUCCESS:return ret
	if cd3d.Depth:
		CUDA_MEMCPY3D cp3d;
		memset(&cp3d,0,sizeof(cp3d))
		with cp3d
			.dstMemoryType=CU_MEMORYTYPE_ARRAY;
			.dstArray=a
			.srcMemoryType=CU_MEMORYTYPE_HOST;
			.srcHost=h
			.srcPitch=cd3d.Width*cd3d.NumChannels*getszfm(cd3d.Format)
			.srcHeight=cd3d.Height
			.WidthInBytes=.srcPitch
			.Height=cd3d.Height
			.Depth=cd3d.Depth
		ret=cuMemcpy3D(&cp3d);
		$$cuda.lasterror=ret;
		checkpoint("cpyh2a");
		return ret
	CUDA_MEMCPY2D cp;
	memset(&cp, 0, sizeof(cp))
	ret=cuArrayGetDescriptor(&CUDA_ARRAY_DESCRIPTOR cd,a)
	if ret!=CUDA_SUCCESS:return ret
	with cp
		.dstMemoryType=CU_MEMORYTYPE_ARRAY;
		.dstArray=a
		.srcMemoryType=CU_MEMORYTYPE_HOST;
		.srcHost=h
		.srcPitch=cd.Width*cd.NumChannels*getszfm(cd.Format)
		.WidthInBytes=.srcPitch
		.Height=cd.Height
	ret=cuMemcpy2DUnaligned(&cp);
	$$cuda.lasterror=ret;
	checkpoint("cpyh2a");
	return ret
cpyd2a(CUarray a,void* h)
	ret=cuArray3DGetDescriptor(&CUDA_ARRAY3D_DESCRIPTOR cd3d,a)
	if ret!=CUDA_SUCCESS:return ret
	if cd3d.Depth:
		CUDA_MEMCPY3D cp3d;
		memset(&cp3d, 0, sizeof(cp3d))
		with cp3d
			.dstMemoryType=CU_MEMORYTYPE_ARRAY;
			.dstArray=a
			.srcMemoryType=CU_MEMORYTYPE_DEVICE;
			.srcDevice=(CUdeviceptr)h
			.srcPitch=cd3d.Width*cd3d.NumChannels*getszfm(cd3d.Format)
			.srcHeight=cd3d.Height
			.WidthInBytes=.srcPitch
			.Height=cd3d.Height
			.Depth=cd3d.Depth
		ret=cuMemcpy3D(&cp3d);
		$$cuda.lasterror=ret;
		checkpoint("cpyd2a");
		return ret
	CUDA_MEMCPY2D cp;
	memset(&cp, 0, sizeof(cp))
	cuArrayGetDescriptor(&CUDA_ARRAY_DESCRIPTOR cd,a)
	with cp
		.dstMemoryType=CU_MEMORYTYPE_ARRAY;
		.dstArray=a
		.srcMemoryType=CU_MEMORYTYPE_DEVICE;
		.srcDevice=(CUdeviceptr)h
		.srcPitch=cd.Width*cd.NumChannels*getszfm(cd.Format)
		.WidthInBytes=.srcPitch
		.Height=cd.Height
	ret=cuMemcpy2DUnaligned(&cp);
	$$cuda.lasterror=ret;
	checkpoint("cpyd2a");
	return ret

///////////////////////////////////////////
//shared mem, xxxIdx
with detail
	#defhack allocsm "ptxhk-allocsm"
	void transhared(iptr s)
		using meta
		v=(cvar*)s
		feedexpr(&call("operator*",List[&makeerv(v)]))
#def __shared__:
	using meta
	t=atype()
	id=wantid()
	if got(int'['):
		t=typemodifiers(t)
	v=makevar(makeptrtype(t))
	emitcode_clear()
	emitcode_expr(castto(&makeerv(v),t0_iptr))
	write-emitcodef(;"=$$cubsgp.detail.allocsm(",_sizeof(t),",",alignof(t),");spapTargetOption('forceTarget','CUDA');")
	emitcode_flush()
	declare_metaid(id,detail.transhared,(iptr)v)

using meta
static threadIdx
	int x{%get()=__asm__("@return",typeid(iptr),"=threadIdx.x;")}
	int y{%get()=__asm__("@return",typeid(iptr),"=threadIdx.y;")}
	int z{%get()=__asm__("@return",typeid(iptr),"=threadIdx.z;")}
static blockIdx
	int x{%get()=__asm__("@return",typeid(iptr),"=blockIdx.x;")}
	int y{%get()=__asm__("@return",typeid(iptr),"=blockIdx.y;")}
	int z{%get()=__asm__("@return",typeid(iptr),"=blockIdx.z;")}
static blockDim
	int x{%get()=__asm__("@return",typeid(iptr),"=blockDim.x;")}
	int y{%get()=__asm__("@return",typeid(iptr),"=blockDim.y;")}
static gridDim
	int x{%get()=__asm__("@return",typeid(iptr),"=gridDim.x;")}
	int y{%get()=__asm__("@return",typeid(iptr),"=gridDim.y;")}

///////////////////////////////////////////
//primitives
with detail
	struct _rop_add
		__both__ operator()(x,y)=x+y
		__both__ inverse(x)=-x
		__both__ zero(class T)
			If T==int2:
				=make_int2(0,0)
			Elif T==uint2:
				=make_uint2(0,0)
			Else
				=T 0
	_rop_add inst_rop_add
	struct _rop_min
		__both__ operator()(x,y)
			return min(x,y)
		__both__ zero(class T)
			const
				tid=typeid(T)
			If tid==t0_u32:{return -1u
			}Elif tid==t0_i32:{return 0x7fffffff
			}Elif tid==t0_u64:{return -1Lu
			}Elif tid==t0_i64:{return 0x7fffffffffffffffLu
			}Elif tid==t0_f32:{return __int_as_float(0x7f7fffff)
			}Else /error("unsupported type for rop_min")
	_rop_min inst_rop_min
	struct _rop_max
		__both__ operator()(x,y)
			return max(x,y)
		__both__ zero(class T)
			const
				tid=typeid(T)
			If tid==t0_u32:{return 0u
			}Elif tid==t0_i32:{return 0x80000000
			}Elif tid==t0_u64:{return 0Lu
			}Elif tid==t0_i64:{return 0x8000000000000000Lu
			}Elif tid==t0_f32:{return __int_as_float(0xff7fffff)
			}Else /error("unsupported type for rop_max")
	_rop_max inst_rop_max
__define__ rop_add "$$cubsgp.detail.inst_rop_add"
__define__ rop_min "$$cubsgp.detail.inst_rop_min"
__define__ rop_max "$$cubsgp.detail.inst_rop_max"
//grand scan
/*
current effective bandwidth for 16M scan:
	50G/s
Deng Ke's notes:
	scan is memory bound
	test confirmed:
		bandwidth: 80G/6G = 12.5
		performance: 39/3.1 = 12.8
*/
with spap.thread
	static block
		iptr size
			__host__ %set(iptr x)
				//should work in require
				char[64]buf
				sprintf(buf,"+cudaBlockSize=%d",x)
				spapSetLocalOption(buf)
			__host__ %get()=(int()()spapGetGpuApi("cudaGetLastBlockSize"))()
		void needshared(iptr a)
			char[64]buf
			sprintf(buf,"+cudaSharedMemSize=%d",a)
			spapSetLocalOption(buf)
		void requiresPowerOfTwoSize()
			spapSetLocalOption("+cudaRequiresPowerOfTwoBlockSize=1")
		__device__ void* getSharedBase()
			__asm__("{extern __shared__ int4 __spap_shared_base[];","@prelive")
			ret=__asm__("@return",meta.typeid(void*),"=(void*)__spap_shared_base")
			__asm__("}","@prelive")
			return ret
#def extern__shared__:
	t=atype()
	id=wantid()
	if want(int'['):
		skip(int']')
	emitcode_clear()
	write-emitcodef(;*char**id,"=($$system.meta.typefromiptr(",t,")*)$$spap.thread.block.getSharedBase();")
	emitcode_flush()
with $$cuda
	void* sharedbase
		__device__ get()=thread.block.getSharedBase()
with detail{
const
	thgscan=128
	size_xchgbuf=4096
	ntexscan=524288
	ncpuscan=size_xchgbuf/sizeof(int)
	ngeneral_scan=524288
texture(int2) texintscan0;
__device__ devscan3(how,x,sbuf00)
	sbuf0=__volatile__(sbuf00)
	typedef typeof(x) T
	typedef typeof(*sbuf0) Tstd
	thid=threadIdx.x;
	a=sbuf0+1;
	if thid==0:a[-1]=*(Tstd*)&how.zero(T);
	p0=a+thid
	p1=a+thid*2
	a[(thid>>4)+(thid&15)*(blockDim.x>>4)]=*(Tstd*)&x;
	if(thid<256-blockDim.x):p0[blockDim.x]=*(Tstd*)&how.zero(T);
	For i=0:7
		__syncthreads();
		if thid<=(256>>(i+1))-1:
			v0=p1[(256*2-((256*2)>>i))]
			v1=p1[1+(256*2-((256*2)>>i))]
			p0[(256*2-(256>>i))]=*(Tstd*)&how(
				*(T*)&v0,
				*(T*)&v1);
	For i=7:-1:0
		if(thid<=(256>>(i+1))-1)
			p=p0[(256*2-(256>>i))];
			p1[1+(256*2-((256*2)>>i))]=p;
			if thid<=(256>>(i+1))-1-1:
				v2=p1[2+(256*2-((256*2)>>i))]
				p1[2+(256*2-((256*2)>>i))]=*(Tstd*)&how(
					*(T*)&p,
					*(T*)&v2);
		__syncthreads();
	thid=threadIdx.x
	vret=sbuf0[(thid>>4)+(thid&15)*(blockDim.x>>4)];
	return *(T*)&vret
__device__ void grandscan(const pass,const usetex,int ofs0,int* src,int* devs0,int* b,
int ntot,int neach,int strt,int* scantmp){
	//padding: once every 16 for per-thread add, once every 16*17 for load
	int bid=blockIdx.x;
	int thid=threadIdx.x;
	int id=bid*thgscan+thid;
	int ldid=(thid>>4),ldofs=(thid&15);
	__shared__ int[128+128*17+128/16] shi
	int* ldp=shi;
	int* ldbuf=shi+thgscan;
	int* pv=ldbuf+(thid*17+ldid);

	if(neach*bid*thgscan>=ntot-ofs0){
		If pass==0:
			if(thid==0)
				b[blockIdx.x]=0;
		return;
	}
	int ps=neach*id;
	int c=0;
	ldp[thid]=ps+ofs0;
	If pass==1:{
		if thid==0:
			c=strt;
			for(int i=0;i<bid;i++)
				c+=scantmp[i];
			ldp[thgscan]=c
		__syncthreads()
		c=devs0[id]+ldp[thgscan]
	}
	id2=(thid&~15)*17+ldid
	pldb=__volatile__(ldbuf+(id2+ldofs))
	pldp=__volatile__(ldp+ldid)
	If pass==1:
		int[16] lv
	int[16] lv2
	__syncthreads();
	for(;ldofs<neach;ldofs+=16){
		For i=0:15{
			int \ps=pldp[(thgscan>>4)*i]+ldofs;
			If usetex:
				d2=tex1Dfetch(.texintscan0,ps)
			Else
				if ps<ntot:
					d2=((int2*)(void*)src)[ps]
				else
					d2=make_int2(0,0)
			If pass==1:
				lv[i]=d2.x
			lv2[i]=d2.x+d2.y
		}
		For i=0:15
			pldb[i*17]=lv2[i]
		For i=0:15
			int v=pv[i];
			If pass==1:pv[i]=c;
			c+=v;
		If(pass==1):{
			For i=0:15
				lv2[i]=pldb[i*17]
			For i=0:15{
				int ps=pldp[(thgscan>>4)*i]+ldofs;
				if(ps<ntot){
					v=lv2[i];lv[i]+=v;
					((int2*)(void*)b)[ps]=make_int2(v,lv[i]);
				}
			}
		}
	}
	If(pass==0):
		__syncthreads()
		int id=blockIdx.x*thgscan+threadIdx.x;
		c=devscan3(rop_add,c,shi);
		devs0[id]=c;
		if(threadIdx.x==0)
			b[blockIdx.x]=pldp[511];
}
%int divup(int a,int b)=(a+b-1)/b
//ported from legacy CUDA code
__host__ scan_passes(const usetex,int ofs0,int *devs0,int *b,int* a,int ntot,int* scantmp,int strt)
	//offset for texture
	/*writeln(devs0,' ',b,' ',scantmp,' ',ofs0,' ',ntot,' ',strt)
	readln*/
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	nbgscan=4*ncore
	nscan=nbgscan*thgscan
	neach=((divup(ntot,nscan)+15)&~15)
	if !(neach&31):neach+=16
	ntot+=ofs0
	b-=ofs0*2
	spawn nscan
		spapTargetOption('cudaLaunchMethod','cudevSysKernel')
		require
			thread.block.size=thgscan
		grandscan(0,usetex,ofs0,a,devs0,scantmp,ntot,neach,0,scantmp);
		barrier
		grandscan(1,usetex,ofs0,a,devs0,b,ntot,neach,strt,scantmp);
const
	thgred=256
//dlist(int)* scanbuf
//	%get()=(dlist(int)*)cuda.detail.curpctx.scanbuf
//void* xchgbuf
//	%get()=cuda.detail.curpctx.xchgbuf
//void init_scanbuf()
//	if !detail.scanbuf.n:
//		detail.scanbuf.clear_resize_exact(nbgscan*thgscan)
}
__host__ int scan_start(int *tar,int *p,int n,int st)
	if(!n):return st;
	if(n<ncpuscan){
		buf=new int[n];
		cpyd2h(buf,p,n*sizeof int);
		int c=st;
		for(int i=0;i<n;i++)
			int a=buf[i];
			buf[i]=c;
			c+=a;
		cpyh2d(tar,buf,n*sizeof int);
		delete buf
		return c;
	}
	int ofs0=((((int)p)&255)>>3);
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	nbgscan=4*ncore
	scanbuf=dnew int[nbgscan*thgscan+nbgscan]
	pscantmp=scanbuf+nbgscan*thgscan
	if n<ntexscan:
		scan_passes(0,ofs0,scanbuf,tar,p-ofs0*2,n/2,pscantmp,st)
	else
		detail.texintscan0.settype(int2)
		detail.texintscan0.bind(null,p-ofs0*2,(n+ofs0*2)*sizeof(int));
		scan_passes(1,ofs0,scanbuf,tar,null,n/2,pscantmp,st)
	rd=new int[nbgscan];
	cpyd2h(rd,pscantmp,nbgscan*4);
	int rt=st;
	for(int i=0;i<nbgscan;i++)
		//write(rd[i],' ')
		rt+=rd[i];
	if n&1:
		cpyd2h(rd,p+(n-1),4);
		cpyh2d(tar+(n-1),&rt,4);
		rt+=rd[0]
	ddelete scanbuf
	delete rd
	return rt;
__host__ scan(int *tar,int *p,int n)=scan_start(tar,p,n,0);
__host__ reduce(how,dd,int n)
	typedef typeof(dd[0]) T
	if !n:
		return how.zero(T)
	if n<ncpuscan*4/sizeof T:
		buf=new T[n];
		cpyd2h(buf,T*dd,n*sizeof T);
		c=how.zero(T)
		for i=0:n-1
			c=how(c,buf[i])
		delete buf
		return c;
	tmp;
	nbgred=4*(int()()spapGetGpuApi("cudaGetCoreCount"))()
	If sizeof(T)==4:
		tmp2=new T[nbgred]
		for i=0:nbgred-1
			tmp2[i]=how.zero(typeof(dd[0]))
		tmp=dnew T[nbgred]
	Else
		tmp2=new T[thgred]
		for i=0:thgred-1
			tmp2[i]=how.zero(typeof(dd[0]))
		tmp=dnew T[nbgred*thgred]
	spawn(nbgred*thgred)
		spapTargetOption('cudaLaunchMethod','cudevSysKernel')
		require
			thread.block.size=thgred
		\c=how.zero(typeof(dd[0]))
		for i=thread.rank:nbgred*thgred:n-1
			c=how(c,dd[i])
		If sizeof(T)==4:
			__shared__ T[thgred] rb
			i=threadIdx.x
			a=__volatile__(rb+i);
			a[0]=c
			__syncthreads()
			if i<thgred-128:a[0]=how(a[0],a[128])
			__syncthreads()
			if i<64:a[0]=how(a[0],a[64])
			__syncthreads()
			if i<32:
				a[0]=how(a[0],a[32])
				a[0]=how(a[0],a[16])
				a[0]=how(a[0],a[8])
				a[0]=how(a[0],a[4])
				a[0]=how(a[0],a[2])
				if i==0:
					tmp[blockIdx.x]=how(a[0],a[1])
		Else
			tmp[thread.rank]=c
	If sizeof(T)==4:
		cpyd2h(tmp2,(T*)tmp,nbgred*sizeof T)
	Else
		spawn(thgred)
			spapTargetOption('cudaLaunchMethod','cudevSysKernel')
			require
				thread.block.size=thgred
			\c=how.zero(typeof(tmp[0]))
			for i=thread.rank:thgred:nbgred*thgred-1
				c=how(c,tmp[i])
			tmp[thread.rank]=c
		cpyd2h(tmp2,(T*)tmp,thgred*sizeof T)
	ddelete tmp
	c=tmp2[0]
	//If T==int:
	//	write(c)
	If sizeof(T)==4:
		for i=1:nbgred-1
			c=how(c,tmp2[i])
	Else
		for i=1:thgred-1
			c=how(c,tmp2[i])
	//If T==int:
	//	writeln
	delete tmp2
	return c
//device reduce/scan
const
	threduce=256
	smreduce=4*threduce
	thscan=256
	smscan=8*thscan
__device__ scan_total(x)=(typeof(x)*cuda.sharedbase)[thscan]
//collective library
using meta,compiler
/*
x is a boolean, compact a and append to list L
	kind:
		0: clear and add
		1: append
		2: add to temp
	issplit:
		0: compact
		1: split
	return # elements added if L is list
	a could be list or computed value (stored temporarily)
*/
const
	target_clear=0
	target_append=1
	target_allocator=3
	target_pointer=4
	target_clear_exact=5
with detail{
struct ccompact_rank_hlp
	int dummy
__device__ compact_or_split(__host__ L,a,int x_0,const kind,const issplit)
	typedef typeof(a) T
	const isdlist=thasmember(typeid(T))&&findmember(typeid(T),getid("__is_dlist"))
	const isdtlist=thasmember(typeid(T))&&findmember(typeid(T),getid("__is_dtemplist"))
	typedef typeof(L) TL
	const Lisdlist=thasmember(typeid(TL))&&findmember(typeid(TL),getid("__is_dlist"))
	If isdlist||tispointer(typeid(T))||isdtlist:
		If isdlist:
			typedef typefromiptr((ctype*typeid(T)).t0).T T0
		Elif isdtlist:
			typedef typeof(a).T T0
		Else
			typedef typeof(*a) T0
	Elif typeid(T)==typeid(detail.ccompact_rank_hlp):
		typedef int T0
	Elif tisstruct(typeid(T))&&findmember(typeid(T),getidentifier(operator()))
		typedef typeof(a()) T0
	Else
		typedef T T0
	If tisstruct(typeid(T0))&&!findmember(typeid(T0),getid("__is_vector")):
		/error("compact/split of complicated type isn't supported yet")
	If isdlist&&tisstruct(typeid(T0))&&!findmember(typeid(T0),getid("__is_vector")):
		static tex
			texture(int) t1
			texture(int2) t2
			texture(int4) t4
		require
			iptr n
			dtemplist(iptr) tmp
		x=x_0
		n=compact_or_split(&tmp,ccompact_rank_hlp aaaa,x,2,issplit)
		barrier require
			tex.t1.address=a.__getptr()
			tex.t2.address=a.__getptr()
			tex.t4.address=a.__getptr()
			If kind==target_templist||kind==target_allocator:
				error("target_templist isn't supported for struct")
			Elif kind==target_clear:
				L.clear_resize(n)
			Elif kind==target_clear_exact:
				L.clear_resize_exact(n)
			Elif kind==target_append:
				ofs=L.addn(n)
		/
			sd=get_Struct(typeid(T))
			emitcode_clear()
			id___sz=getid("__sz")
			write-emitcodef(;"require{ofs_0=a.__getptr();")
			gotthere=0
			for dd:sd
				if dd.what!=declarable.variable:continue
				if dd.id==id___sz:
					gotthere=1
					continue
				if !gotthere:continue
				v=variable*dd
				s=*char**v.id
				//the offset getting code
				write-emitcodef(;"ofs_",s,"=(iptr a.",s,"-iptr ofs_0)/",_sizeof(v.t),";")
			write-emitcodef(;
			"}if thread.rank<n:{",
			"oldrank=tmp[thread.rank];")
			gotthere=0
			for dd:sd
				if dd.what!=declarable.variable:continue
				if dd.id==id___sz:
					gotthere=1
					continue
				if !gotthere:continue
				v=variable*dd
				s=*char**v.id
				//the storing code
				sz=_sizeof(v.t)/4
				write-emitcodef(;"L.",s,"[",kind==1?"ofs+":"","thread.rank]=tex.t",sz,"[ofs_",s,"+oldrank];")
			write-emitcodef(;"}")
			emitcode_flush()
	Else{
	x=x_0
	If issplit:
		x=!x
	Else
		x=!!x
	require
		tmplist=new dlist(int)(thread.size)
		tmp=tmplist.d
	tmp[thread.rank]=x
	barrier require
		n=scan(tmp,tmp,thread.size)
		If issplit:
			n0=n
			n=thread.size
		If kind==target_allocator:
			alloced_list=L(n)
		Elif kind==target_clear:
			If Lisdlist:
				L.clear_resize(n)
		Elif kind==target_clear_exact:
			If Lisdlist:
				L.clear_resize_exact(n)
		Elif kind==target_append:
			ofs=L.n
			L.addn(n)
	If kind==target_allocator:
		__define__ storep "alloced_list[p]=v"
	Elif kind==target_clear||kind==target_clear_exact||kind==target_pointer:
		__define__ storep "L[p]=v"
	Elif kind==target_append:
		__define__ storep "L[p]=v"
	If isdlist:
		require
			iscpu(a)
	If kind==target_pointer:
		require
			iscpu(L)
	/*require
		thread.block.needshared(sizeof(iptr)*(thread.block.size+1))*/
	require(1)
		tmplist.discard()
	p=tmp[thread.rank]
	if thread.rank==thread.size-1:
		If issplit:
			nscan=n0
		Else
			nscan=n
		x=nscan-p
	else
		x=tmp[thread.rank+1]-p
	/*cubsgp_API_end()
	cubsgp_API_begin()
	thread.block.synced
		__syncthreads()
	extern__shared__ int sh[]
	sh[threadIdx.x]=p
	if threadIdx.x==0:
		if blockIdx.x==gridDim.x-1:
			If issplit:
				nscan=n0
			Else
				nscan=n
			sh[thread.size-blockIdx.x*thread.block.size]=nscan
		else
			//PTXcomment "inner block"
			sh[thread.block.size]=tmp[thread.rank+thread.block.size]
	thread.block.synced
		__syncthreads()
	x=sh[threadIdx.x+1]-p
	cubsgp_API_end()
	cubsgp_API_begin()*/
	if issplit||x:
		If isdlist||tispointer(typeid(T))||isdtlist:
			v=a[thread.rank]
		Elif typeid(T)==typeid(detail.ccompact_rank_hlp)
			v=thread.rank
		Elif tisstruct(typeid(T))&&findmember(typeid(T),getidentifier(operator()))
			v=a()
		Else
			v=a
		If issplit:
			if !x:
				p=thread.rank-p+n0
		If kind==target_append:
			p+=ofs
		storep
	If issplit:
		return __host__(0) n0
	Else
		return __host__(0) n
	}
}
//compact and split
__device__ compact(__host__ L,a,int x,const kind)
	ret=detail.compact_or_split(L,a,x,kind,0)
	return __host__(0) ret
__device__ compact_rank(__host__ L,int x,const kind)
	ret=compact(L,ccompact_rank_hlp a,x,kind)
	return __host__(0) ret
__device__ split(__host__ L,a,int x,const kind)
	ret=detail.compact_or_split(L,a,x,kind,1)
	return __host__(0) ret
//append and scan
__device__ iptr append(__host__ L,iptr &x,const kind)
	require
		tmplist=new dlist(iptr)(thread.size)
		tmp=tmplist.d
	tmp[thread.rank]=x
	barrier require
		If typeid(typeof(L))==typeid(iptr)
			ret=scan_start(tmp,tmp,thread.size,L)
		Else
			ret=scan(tmp,tmp,thread.size)
		If typeid(typeof(L))==typeid(iptr):
			;//just scan_start
		Elif kind==target_allocator:
			ret2=L(ret)
		Elif kind==target_clear:
			L.clear_resize(ret)
		Elif kind==target_clear_exact:
			L.clear_resize_exact(ret)
		Elif kind==target_append:
			ofs=L.n
			L.addn(ret)
		Elif kind==target_pointer:
		Else
			error("target_??? isn't supported for append")
	p=tmp[thread.rank]
	x=p
	require(1)
		tmplist.discard()
	If kind==target_append:
		x+=ofs
	return __host__ ret
__device__ iptr scan(iptr &x)
	require
		ret=0
	ret=append(0,x,0)
	return __host__ ret
__device__ iptr scan_start(iptr &x,__host__ iptr stt)
	require
		ret=0
	ret=append(stt,x,0)
	return __host__ ret
//grandscan_how
//todo: 64-bit int handling
with detail{
const
	thgscan2=128
__device__ void grandscan_how(
const pass,const usetex,__host__ how,
int ofs0,src,devs0,scantmp,b,int ntot,int neach)
	typedef typeof(b[0]) T
	If sizeof T==4:
		typedef int Tstd
	Else
		typedef int2 Tstd
	If (sizeof T!=4)&(sizeof T!=8):
		/error("scan is only supported for 4 or 8 byted data")
	int bid=blockIdx.x;
	int thid=threadIdx.x;
	int id=bid*thgscan2+thid;
	int ldid=(thid>>4),ldofs=(thid&15);
	__shared__ int2[(thgscan2*2+thgscan2*17+thgscan2/16+1)/2] shi2
	int* shi=__volatile__((int*)shi2);
	int* ldp=__volatile__(shi);
	int* ldbuf=__volatile__(shi+thgscan2*2);
	int* pv=__volatile__(ldbuf+(thid*17+ldid));

	//ntot has ofs0 added to it for the later cmps
	if neach*bid*thgscan2>=ntot-ofs0:
		If pass==0:
			if thid==0
				v=how.zero(typeof(b[0]))
				scantmp[blockIdx.x]=*Tstd*&v
		return
	int ps=neach*id;
	c=how.zero(typeof(b[0]));
	ldp[thid]=ps+ofs0;
	If pass==1:
		if thid==0:
			cc=how.zero(typeof(b[0]));
			for i=0:bid-1
				v=scantmp[i]
				cc=how(cc,*T*&v);
			*Tstd*void*&ldp[thgscan2]=*(Tstd*)&cc
		__syncthreads()
		v=*Tstd*void*&ldp[thgscan2]
		v2=((Tstd*)devs0)[id]
		c=how(*T*void*&v,*T*void*&v2)
	id2=(thid&~15)*17+ldid
	pldb=__volatile__(ldbuf+(id2+ldofs))
	pldp=__volatile__(ldp+ldid)
	If (pass==1)|(sizeof(T)==8):
		int[16] lv
	int[16] lv2
	__syncthreads();
	for(;ldofs<neach;ldofs+=16)
		If sizeof T==4:
			For i=0:15
				int ps=pldp[thgscan2/16*i]+ldofs;
				if ps<ntot:
					If usetex:
						d2=tex1Dfetch(.texintscan0,ps)
					Else
						d2=src[ps]
				else
					*T*&d2.x=how.zero(typeof(b[0]))
					*T*&d2.y=how.zero(typeof(b[0]))
				If pass==1:
					lv[i]=d2.x
				*T*&lv2[i]=how(*T*&d2.x,*T*&d2.y)
			For i=0:15
				pldb[i*17]=lv2[i]
			For i=0:15
				\v=pv[i];
				If pass==1:pv[i]=*int*&c;
				c=how(c,*T*&v);
			If pass==1:
				For i=0:15
					lv2[i]=pldb[i*17]
				For i=0:15
					int ps=pldp[thgscan2/16*i]+ldofs;
					if(ps<ntot)
						*T*&lv[i]=how(*T*&lv2[i],*T*&lv[i])
						((int2*)(void*)b)[ps]=make_int2(lv2[i],lv[i]);
		Else
			For i=0:15
				int ps=pldp[thgscan2/16*i]+ldofs;
				if ps<ntot:
					If usetex:
						d2=tex1Dfetch(.texintscan0,ps)
					Else
						d2=src[ps]
				else
					*T*&d2=how.zero(typeof(b[0]))
				lv2[i]=d2.y
				pldb[i*17]=d2.x
			For i=0:15
				lv[i]=pv[i];
			For i=0:15
				pldb[i*17]=lv2[i]
			For i=0:15
				T tmp
				(int2*&tmp).x=lv[i];
				(int2*&tmp).y=pv[i];
				If pass==1:
					lv[i]=(int2*&c).x
					pv[i]=(int2*&c).y
				c=how(c,tmp)
			If pass==1:
				For i=0:15
					lv2[i]=pldb[i*17]
				For i=0:15
					pv[i]=lv[i]
				//__asm__("@prelive","/*here*/")
				/*For i=0:15
					lv[i]=pldb[i*17];*/
				For i=0:15
					int ps=pldp[thgscan2/16*i]+ldofs;
					xx=pldb[i*17]
					if ps<ntot:
						((int2*)b)[ps]=make_int2(xx,lv2[i]);
	If pass==0:
		__syncthreads()
		int id=thread.rank
		c=devscan3(how,c,Tstd*shi);
		((Tstd*)devs0)[id]=*(Tstd*)&c
		if threadIdx.x==0:
			scantmp[blockIdx.x]=(Tstd*shi)[511];
//general how scan
__host__ auto general_scan(how,tar,src,n)
	const
		type_id=meta.typeid(typeof(tar))
	If meta.thasmember(type_id)&&meta.findmember(type_id,meta.getid('__is_dlist')):
		typedef typeof(tar).T T
		T result
		if n<1024:
			cc=how.zero(T)
			for i=0:n-1
				v=src[i]
				tar[i]=cc
				cc=how(cc,v)
			return cc
	Else
		typedef typeof(tar[0]) T
		T result
		if n<1024:
			cc=how.zero(T)
			if !n:return cc
			ctots=new T[n]
			cpyd2h(ctots,src,sizeof(T)*n)
			for i=0:n-1
				v=ctots[i]
				ctots[i]=cc
				cc=how(cc,v)
			cpyh2d(tar,ctots,sizeof(T)*n)
			delete ctots
			return cc
	const
		N_SCANNER=128
		BATCH_SIZE=(((16384-256)/sizeof(T)-N_SCANNER)&(-128/(sizeof(T)&-sizeof(T))))
		PER_THREAD=(((BATCH_SIZE+N_SCANNER-1)/N_SCANNER)|1)
		LOCAL_SCAN=2
		LEFTOVER=N_SCANNER/LOCAL_SCAN
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	ntscan0=ncore*1024
	nbatches=(n+BATCH_SIZE-1)/BATCH_SIZE
	ntots=nbatches*LEFTOVER
	tots=dnew T[ntots]
	forall ii=0:ntscan0-1
		spapTargetOption('cudaLaunchMethod','cudevSysKernel')
		require
			thread.block.size=512
		__shared__ T[BATCH_SIZE] a
		__shared__ T[N_SCANNER] lbuf
		for bid=blockIdx.x:gridDim.x:nbatches-1
			p=BATCH_SIZE*bid
			per_block=min(n-p,BATCH_SIZE)
			for j=threadIdx.x:blockDim.x:per_block-1
				a[j]=src[p+j]
			__syncthreads()
			if threadIdx.x<N_SCANNER:
				c=how.zero(T)
				p2=threadIdx.x*PER_THREAD
				for j=p2:min(per_block,p2+PER_THREAD)-1
					v=a[j]
					a[j]=c
					c=how(c,v)
				lbuf[threadIdx.x]=c
			__syncthreads()
			if threadIdx.x<LEFTOVER:
				c=lbuf[threadIdx.x*LOCAL_SCAN]
				For j=1:LOCAL_SCAN-1
					c=how(c,lbuf[threadIdx.x*LOCAL_SCAN+j])
				tots[bid*LEFTOVER+threadIdx.x]=c
			for j=threadIdx.x:blockDim.x:per_block-1
				v=a[j]
				scanner_id=j/PER_THREAD
				if scanner_id&1:
					c=lbuf[scanner_id-1]
					v=how(c,v)
				tar[p+j]=v
	//writeln(tots.n)
	cc=general_scan(how,tots,tots,ntots)
	forall i=0:n-1
		spapTargetOption('cudaLaunchMethod','$$cuda.cudevBigLoop')
		v=tar[i]
		bid=i/BATCH_SIZE
		thid=(i-bid*BATCH_SIZE)/(PER_THREAD*LOCAL_SCAN)
		ttid=bid*LEFTOVER+thid
		tar[i]=how(tots[ttid],v)
	ddelete tots
	return cc
}//detail
//how scan
__host__ scan(how,tar,p,int n)
	typedef typeof(p[0]) T
	If sizeof(T)!=4:
		return general_scan(how,tar,p,n)
	Else{
	If T==int&&typeof(how)==_rop_add:
		return scan(tar,p,n)
	if !n:return how.zero(T)
	if n<ncpuscan*4/sizeof T:
		buf=new T[n];
		cpyd2h(buf,T*p,n*sizeof T);
		c=how.zero(T);
		for i=0:n-1
			v=buf[i]
			buf[i]=c
			c=how(c,v)
		cpyh2d(T*tar,buf,n*sizeof T);
		delete buf
		return c;
	if n>=ngeneral_scan:
		return general_scan(how,tar,p,n)
	tmp;
	If sizeof T==4:
		typedef int Tstd
		ntot=(n>>1)
	Elif sizeof(T)==8:
		typedef int2 Tstd
		ntot=n
	Else
		/meta.error("only 4 or 8 bytes values are supported for scan")
	nbgscan=4*(int()()spapGetGpuApi("cudaGetCoreCount"))()
	neach=((divup(ntot,nbgscan*thgscan)+15)&~15)
	if !(neach&31):neach+=16
	ofs0=((((int)p)&255)>>3);
	ntot+=ofs0
	src=int2*T*p-ofs0
	rd=new T[nbgscan];
	if n<ntexscan:
		spawn nbgscan*thgscan2
			spapTargetOption('cudaLaunchMethod','cudevSysKernel')
			require
				thread.block.size=thgscan2
				tmp=dnew Tstd[nbgscan]
				tmp2=(T*)(Tstd*)(dnew Tstd[nbgscan*thgscan2])
			grandscan_how(0,0,how,ofs0,src,tmp2,tmp,tar,ntot,neach)
			barrier
			require
				thread.block.size=thgscan2
			grandscan_how(1,0,how,ofs0,src,tmp2,tmp,tar,ntot,neach)
			require(1)
				cpyd2h(rd,(T*)(Tstd*)tmp,nbgscan*sizeof T);
				ddelete tmp2
				ddelete tmp
	else
		detail.texintscan0.settype(int2)
		detail.texintscan0.bind(null,src,(ntot+ofs0)*sizeof int2);
		spawn nbgscan*thgscan2
			spapTargetOption('cudaLaunchMethod','cudevSysKernel')
			require
				thread.block.size=thgscan2
				tmp=dnew Tstd[nbgscan]
				tmp2=(T*)(Tstd*)(dnew Tstd[nbgscan*thgscan2])
			grandscan_how(0,1,how,ofs0,src,tmp2,tmp,tar,ntot,neach)
			barrier
			require
				thread.block.size=thgscan2
			grandscan_how(1,1,how,ofs0,src,tmp2,tmp,tar,ntot,neach)
			require(1)
				cpyd2h(rd,(T*)(Tstd*)tmp,nbgscan*sizeof T);
				ddelete tmp2
				ddelete tmp
	rt=how.zero(T);
	for i=0:nbgscan-1
		rt=how(rt,rd[i])
	If sizeof T==4:
		if n&1:
			cpyd2h(rd,p+(n-1),sizeof T);
			cpyh2d(tar+(n-1),&rt,sizeof T);
			rt=how(rt,rd[0])
	delete rd
	return rt;
	}
//collective form reduce
__device__ reduce(__host__ how,d)
	typedef typeof(d) T
	require
		tmplist=new dlist(T)(thread.size)
		tmp=tmplist.d
	tmp[thread.rank]=d
	barrier require
		ret=reduce(how,tmp,thread.size)
	require(1)
		tmplist.discard()
	return __host__ ret
//collective scan
__device__ scan(__host__ how,&x)
	const
		bundle_size=131072
	typedef typeof(x) T
	require
		tmplist=new char<sizeof(T)*thread.size>
		tmp=(T*)tmplist.d
	tmp[thread.rank]=x
	barrier require
		ttot=scan(how,tmp,tmp,thread.size)
	x=tmp[thread.rank]
	require(1)
		tmplist.discard()
	return __host__ ttot
__device__ rscan(__host__ how,&x)
	typedef typeof(x) T
	require
		tmplist=new char<sizeof(T)*thread.size>
		tmp=(T*)tmplist.d
	tmp[thread.size-1-thread.rank]=x
	barrier require
		ttot=scan(how,tmp,tmp,thread.size)
	x=tmp[thread.size-1-thread.rank]
	require(1)
		tmplist.discard()
	return __host__ ttot
__device__ riscan(__host__ how,&x)
	x0=x
	tot=rscan(how,x)
	x=how(x,x0)
	return __host__ tot
__device__ iscan(__host__ how,&x)
	x0=x
	tot=scan(how,x)
	x=how(x,x0)
	typedef typeof(tot) T
	return __host__ tot
//scan on segments resulting from rake
//requires group
__device__ raked_scan(how,&x)
	//even this clutter is faster than outer scan!
	typedef typeof(x) T
	If sizeof T==4:
		typedef int Tstd
	Else
		typedef int2 Tstd
	require
		tmp=dtempnew[thread.size+1]Tstd
		btmp=dtempnew[thread.grid.size+1]Tstd
	ow=thread.oldrank
	btot=thread.block.scan(how,x)
	if threadIdx.x==0:
		btmp[blockIdx.x]=*Tstd*&btot
		if blockIdx.x==gridDim.x-1:
			if thread.size&(thread.block.size-1):
				tmp[thread.size]=*Tstd*&btot
			else
				tmp[thread.size]=*Tstd*&how.zero(typeof(x))
	tmp[thread.rank]=x
	barrier require
		__reserve_temp((nbgscan+nbgscan*thgscan)*sizeof T+512)
		tot=scan(how,T*Tstd*btmp,T*Tstd*btmp,thread.grid.size)
		cpyh2d(Tstd*btmp+thread.grid.size,&tot,sizeof tot)
	id=thread.rank
	p0=thread.__last_rake_obase[ow]
	p1=thread.__last_rake_obase[ow+1]
	xi=tmp[id];vi=btmp[int(u32 id/u32 thread.block.size)];xi=*Tstd*&how(*T*&vi,*T*&xi)
	x0=tmp[p0];v0=btmp[int(u32 p0/u32 thread.block.size)];x0=*Tstd*&how(*T*&v0,*T*&x0)
	x1=tmp[p1];v1=btmp[int(u32 p1/u32 thread.block.size)];x1=*Tstd*&how(*T*&v1,*T*&x1)
	ix0=how.inverse(*T*&x0)
	x=how(ix0,*T*&xi)
	segtot=how(ix0,*T*&x1)
	return segtot
//isort
with detail{
const
	logTsel=3
	Tsel=(1<<logTsel)
//texture(int) keya
bsmerge(kb,int* b,ka,int* a,int n,int sz,less)
	typedef typeof(*kb) T
	typedef getTexType(T).ret Ttex
	//typedef void Ttex
	If Ttex!=void:
		texture(Ttex) key
		key.address=(Ttex*)ka
	spawn n
		id=thread.rank
		k0=ka[id]
		k=k0
		l0=l=((id&-sz)^sz);r=min(l+sz,n)-1
		if id&sz:
			while l<=r:
				m=(l+r)>>1
				If Ttex!=void:
					rk0=key.loadas(Ttex,m)
					If T==i64:
						rk=(i64)rk0.x+((i64)rk0.y<<32)
					Elif T==u64:
						rk=(u64)(u32)rk0.x+((u64)(u32)rk0.y<<32)
					Else
						rk=*(T*)&rk0
				Else
					rk=ka[m]
				if !less(k,*T*&rk):{l=m+1}else r=m-1
		else
			while l<=r:
				m=(l+r)>>1
				If Ttex!=void:
					rk0=key.loadas(Ttex,m)
					If T==i64:
						rk=(i64)rk0.x+((i64)rk0.y<<32)
					Elif T==u64:
						rk=(u64)(u32)rk0.x+((u64)(u32)rk0.y<<32)
					Else
						rk=*(T*)&rk0
				Else
					rk=ka[m]
				if less(*T*&rk,k):{l=m+1}else r=m-1
		c=(id&~sz)-l0+l
		kb[c]=k0
		b[c]=a[id]
}
void iscpu(v);
with detail
	struct getTexType(T)
		If sizeof(T)==1:
			typedef i8 ret
		Elif sizeof(T)==2:
			typedef i16 ret
		Elif sizeof(T)==4:
			typedef i32 ret
		Elif sizeof(T)==8:
			typedef int2 ret
		Elif sizeof(T)==16:
			typedef int4 ret
		Else
			typedef void ret
void sort_stuff(int* a0,ka0,int n,less)
	ka=ka0
	typedef typeof(*ka) T
	if n>(1<<27):
		checkpoint_error('unable to bind texture for sort')
	b=dnew[n]int
	kb=dnew[n]T
	a=int*a0
	bsz=128
	spawn n
		spapTargetOption('cudaLaunchMethod','cudevSysKernel')
		require
			thread.block.size=256
		__shared__ T sb[256]
		__shared__ int sbi[256]
		id=threadIdx.x
		if thread.rank<n:
			k=ka[thread.rank]
			sb[id]=k
		__syncthreads()
		//1.0 bug here: compiled the - into +
		nn=thread.size-blockIdx.x*blockDim.x
		l=(id&-Tsel);r=min(l+Tsel,nn)-1
		c=l
		for i=l:id-1
			c+=!less(k,sb[i])
		for i=id:r
			c+=less(sb[i],k)
		__syncthreads()
		if id<nn:
			sb[c]=k
			sbi[c]=thread.rank
		For i=logTsel:8
			if (1<<i)<256{
			__syncthreads()
			sz=(1<<i)
			k0=sb[id]
			k=k0
			l0=l=((id&-sz)^sz);r=min(l+sz,nn)-1
			if id&sz:
				while l<=r:
					m=(l+r)>>1
					if !less(k,sb[m]):{l=m+1}else r=m-1
			else
				while l<=r:
					m=(l+r)>>1
					if less(sb[m],k):{l=m+1}else r=m-1
			id0=sbi[id]
			__syncthreads()
			c=(id&~sz)-l0+l
			if id<nn:
				sb[c]=k0
				sbi[c]=id0
			}
		__syncthreads()
		kb[thread.rank]=sb[threadIdx.x]
		b[thread.rank]=sbi[threadIdx.x]
		require(1)
			bsz=(int()()spapGetGpuApi("cudaGetLastBlockSize"))()
	//PTXcomment "finally... here"
	for(sz=bsz;sz<n;sz+=sz)
		//indeed some improvement
		bsmerge(ka,a,kb,b,n,sz,less)
		tmp=a;a=b;b=tmp
		\tmp=ka;ka=kb;kb=tmp
	if b!=(int*)a0:
		cpyd2d((int*)a0,b,sizeof(int)*n)
		cpyd2d(ka,kb,sizeof(T)*n)
		tmp=a;a=b;b=tmp
		\tmp=ka;ka=kb;kb=tmp
	ddelete ka
	ddelete a
__device__ _sort_idx(a0,k,const delkb)
	typedef typeof(k) T
	require
		iscpu(a0)
		n=thread.size
		kb=dnew[n]T
	kb[thread.rank]=k
	barrier require
		struct lesser
			__device__ operator()(T a,T b)=a<b
		lesser less
		sort_stuff((int*)a0,kb,n,less)
	require(1)
		//writeln('discard: ',kb)
		if delkb:
			ddelete kb
	return __host__ kb
__device__ _sort_idx2(int*a0,k,const dodel)
	If typeid(typeof(k))==t0_f32:
		x=*int*&k
		if x<0:x^=0x7fffffff
		kb=_sort_idx(a0,x,dodel)
	Else
		kb=_sort_idx(a0,k,dodel)
	return __host__ kb
__device__ sort_idx(int*a0,k)=__host__ _sort_idx2(a0,k,1)
__device__ isort_idx(int*a0,int k)
	sort_idx(a0,k)
__device__ int sort_idx(k)
	require
		tmplist=new dlist(int)(thread.size)
		tmp=tmplist.d
	sort_idx(tmp,k)
	require(1)
		tmplist.discard()
	return tmp[thread.rank]
with spap.thread{
__device__ sortby(&k)
	If !meta.tisint(meta.typeid(typeof(k)))&&!meta.tisfloat(meta.typeid(typeof(k))):
		/error("thread.sortby is only supported for basic types")
	require
		tmplist=new dlist(int)(thread.size)
		tmp=tmplist.d
	kb=_sort_idx2(tmp,k,0)
	barrier(1) require(1)
		ddelete kb
		tmplist.discard()
	thread.oldrank=tmp[thread.rank]
	If typeid(typeof(k))==t0_f32:
		x=((int*)kb)[thread.rank]
		if x<0:x^=0x7fffffff
		k=__int_as_float(x)
	Else
		k=kb[thread.rank]
}
//cmp based sort
///////////////////////////////////////////////
__device__ _sort_idx_cmp(a0,k,const delkb,less)
	typedef typeof(k) T
	require
		iscpu(a0)
		n=thread.size
		kb=dnew[n]T
	kb[thread.rank]=k
	barrier require
		sort_stuff((int*)a0,kb,n,less)
	require(1)
		//writeln('discard: ',kb)
		if delkb:
			ddelete kb
	return kb
__device__ sort_idx(int*a0,k,less)=_sort_idx_cmp(a0,k,1,less)
__device__ int sort_idx(k,less)
	Compile
		OnMatch(pf)
			if !thasmember(__expres.d[1].t)&&__expres.d[1].t!=t0_void:
				Match.reject
			else
				Match.standard
	require
		tmplist=new dlist(int)(thread.size)
		tmp=tmplist.d
	sort_idx(tmp,k,less)
	require(1)
		tmplist.discard()
	return tmp[thread.rank]
with spap.thread{
__device__ sortby(&k,less)
	require
		tmplist=new dlist(int)(thread.size)
		tmp=tmplist.d
	kb=_sort_idx_cmp(tmp,k,0,less)
	barrier(1) require(1)
		ddelete kb
		tmplist.discard()
	thread.oldrank=tmp[thread.rank]
	k=kb[thread.rank]
}
///////////////////////////////////////////////
//forking
with detail{
rake_fill(dlist(int) orks,dlist(int4) fjobs,int nfjob)
	lsz=1
	:again
	if nfjob<8:
		int4[8] cjobs
		cpyd2h(cjobs,fjobs.d,nfjob*sizeof int4)
		//note: cuMemsetD32 is a kernel launch
		for i=0:nfjob-1
			cuMemsetD32(orks.d+cjobs[i].x,cjobs[i].z,cjobs[i].y<<lsz)
		checkpoint("rake_simple")
		return
	mk=(1<<lsz)-1
	sz=(1<<lsz)
	/*declare*/nj2;fjobs2;
	spawn nfjob<<lsz
		id=thread.rank>>lsz
		//PTXcomment "what?"
		jb=fjobs[id]
		p=orks.d+jb.x+(thread.rank&mk)
		n=min((jb.y&7)+8,jb.y)
		for i=0:n-1
			p[0]=jb.z
			p+=sz
		barrier(RANK_REASSIGNED) require
			thread.size=nfjob
		thread.oldrank=0
		jb=fjobs[thread.rank]
		n=min((jb.y&7)+8,jb.y)
		jb.x+=n*sz
		jb.y=(jb.y-n)>>3
		require
			fjobs2=new dlist(int4)
		nj2=compact(fjobs2,jb,jb.y>0,target_clear_exact)
	if nj2:
		lsz+=3
		fjobs.discard()
		fjobs=fjobs2
		nfjob=nj2
		goto again
tls_killp=TlsAlloc()
dlist(int)* kill_p
	%get()
		ret=TlsGetValue(.tls_killp)
		if !ret:
			pl=new dlist(int)
			pl._addref()
			ret=(void*)pl
			TlsSetValue(.tls_killp,ret)
		return (dlist(int)*)ret
tls_cuglinited=TlsAlloc()
iptr cuglinited
	%get()=(iptr)TlsGetValue(.tls_cuglinited)
	%set(iptr a)TlsSetValue(.tls_cuglinited,(void*)a)
iptr* kill_help(iptr n)
	.kill_p.discard()
	.kill_p.clear_resize(n)
	return .kill_p.d
}
with spap.thread
	__device__ int kill(int x)
		require
			n=0
		n=compact_rank(detail.kill_help,!x,target_allocator)
		spapTargetOption('cudaLaunchMethod','$$cuda.cudevBigLoop')
		barrier(RANK_REASSIGNED) require
			thread.size=n
			kp=detail.kill_p.d
		require(1)
			detail.kill_p.discard()
		ork=kp[thread.rank]
		.oldrank=ork
		return n
	__device__ int split(int x)
		require
			n=0
		n=split(detail.kill_help,ccompact_rank_hlp a,x,target_allocator)
		barrier(RANK_REASSIGNED) require
			kp=detail.kill_p.d
		require(1)
			detail.kill_p.discard()
		ork=kp[thread.rank]
		.oldrank=ork
		return __host__(0) n
	def respawn:
		//thread.oldrank=0;
		ct=meta.curtarget;meta.curtarget=meta.target_native
		assexpr(&expres en)
		meta.curtarget=ct;
		emitcode_clear()
		write-emitcodef(;"$$spap.barrier(1);require{$$spap.thread.size=")
		emitcode_expr(en)
		write-emitcodef(;"};")
		emitcode_flush()
		return declnothing()
	__device__ int fork()
		barrier(RANK_REASSIGNED) require
			thread.size=thread.size*2
		ork=thread.rank>>1
		.oldrank=ork
		return thread.rank&1
	dtemplist(int) __last_rake_obase
	__device__ int rake(int nteeth)
		//even slow, this wrapping enables carefree coding
		nteeth=max(nteeth,0)
		bc=(nteeth>1)
		p=nteeth
		pbc=bc
		require
			fjobs=new dlist(int4)
			nfjob=0
			ntnew=0
		par
			nfjob=append(fjobs,pbc,target_clear_exact)
			ntnew=scan(p)
		require
			orks=new dlist(int)(ntnew)
			obase=dnew[thread.size+1]int
		obase[thread.rank]=p
		if thread.rank==0:obase[thread.size]=ntnew
		if nteeth&1:
			orks[p++]=thread.rank
		if nteeth>1:
			fjobs[pbc]=make_int4(p,nteeth>>1,thread.rank,0)
		barrier(RANK_REASSIGNED) require
			if nfjob:
				detail.rake_fill(orks,fjobs,nfjob)
			fjobs.discard()
			//writeln('fork: ',ntnew)
			thread.size=ntnew
			/*
			cpyd2h(ww=new[ntnew]int,orks.d,ntnew*4)
			for i=0:ntnew-1
				assert((u32)ww[i]<(u32)cuda.detail.curpctx.BSGPoldsz)
			delete ww
			*/
		ork=orks[thread.rank]
		.oldrank=ork
		require(1)
			orks.discard()
			ddelete obase
		return thread.rank-obase[ork]
	__device__ int fork(int n)=.rake(n)
	__device__ void rerankto(int r2)
		barrier require
			p=dnew[thread.size]int
		p[r2]=thread.rank
		barrier(1) require(1)
			ddelete p
		thread.oldrank=p[thread.rank]
		barrier
//managed GL buffer
_cuGLInit()
	if !detail.cuglinited:{detail.mylazyinit();detail.cuglinited=1;cuGLInit()}

cudaError_t stdcall cudaGLRegisterBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLRegisterBufferObject(bufObj)
	$$cuda.lasterror=ret
	checkpoint('GL reg')
	return ret
cudaError_t stdcall cudaGLMapBufferObject(void **devPtr, u32 bufObj)
	_cuGLInit()
	unused=0
	ret=cuGLMapBufferObject(devPtr,&unused,bufObj)
	$$cuda.lasterror=ret
	checkpoint('GL map')
	return ret
cudaError_t stdcall cudaGLUnmapBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLUnmapBufferObject(bufObj)
	$$cuda.lasterror=ret
	checkpoint('GL unmap')
	return ret
cudaError_t stdcall cudaGLUnregisterBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLUnregisterBufferObject(bufObj)
	$$cuda.lasterror=ret
	checkpoint('GL unreg')
	return ret
If !compiler.getcmdlineoption("CUBSGP_NO_GL"):{
class CGLbuffer
	const
		MIN_VBO_SIZE=1048576
	struct{
	GLuint bo
	iptr n,sz
	novirtual %__init__()
		mylazyinit()
	__done__()
		If GL_USE_PERMANENT:
			gl.permanent.enter()
		if .bo:
			cudaGLUnregisterBufferObject(.bo)
			glDeleteBuffers(1,&.bo)
			.bo=0u
		.n=0
		.sz=0
		If GL_USE_PERMANENT:
			gl.permanent.exit()
	clear_resize(iptr n2)
		.n=n2
		if .n>.sz:
			If GL_USE_PERMANENT:
				gl.permanent.enter()
			if .sz:
				cudaGLUnregisterBufferObject(.bo)
			else
				glGenBuffers(1,&.bo)
			.sz+=.sz
			if .sz<.n:.sz=.n
			if .sz<MIN_VBO_SIZE:.sz=MIN_VBO_SIZE
			If GL_USE_PERMANENT:
				gl.permanent.exit()
		else
			return
		If GL_USE_PERMANENT:
			gl.permanent.enter()
		glGetIntegerv(GL_PIXEL_PACK_BUFFER_BINDING,void*&GLuint bo0)
		glBindBuffer(GL_PIXEL_PACK_BUFFER,.bo);
		//GL_STATIC_DRAW makes address invariant buffer?
		//we want to force it inside...
		//p=new[.sz]char
		//glBufferData(GL_PIXEL_PACK_BUFFER,.sz,p,GL_STATIC_DRAW)
		glBufferData(GL_PIXEL_PACK_BUFFER,.sz,null,GL_STREAM_DRAW)
		//delete p
		cudaGLRegisterBufferObject(.bo)
		glBindBuffer(GL_PIXEL_PACK_BUFFER,bo0);
		If GL_USE_PERMANENT:
			gl.permanent.exit()
	void* map()
		if !.sz:return null
		ret=null
		If GL_USE_PERMANENT:
			gl.permanent.enter()
		cudaGLMapBufferObject(&ret,.bo)
		If GL_USE_PERMANENT:
			gl.permanent.exit()
		return ret
	unmap()
		if .sz:
			If GL_USE_PERMANENT:
				gl.permanent.enter()
			cudaGLUnmapBufferObject(.bo)
			If GL_USE_PERMANENT:
				gl.permanent.exit()
	bind(GLenum what)
		glBindBuffer(what,.bo)
	GLuint d
		%get()=.bo
	void discard()
		.__done__()
	}
}

#def PTXcomment:
	using meta
	s=wantstr()
	feedexpr(&call('__asm__',List[
		&makeerstr("//"),&makeerstr(s),&makeerstr("\n"),&makeerstr("@prelive")]))

%lerp(a,b,float t)=(b-a)*t+a
%mad(float a,float b,float c)=a*b+c
__both__ cross(float3& a,float3& b)=make_float3(
	a.y*b.z-a.z*b.y,
	a.z*b.x-a.x*b.z,
	a.x*b.y-a.y*b.x)

with detail{
#defhack __commget 'metaf-commget'
}
with spap.thread
	__device__ get(int ofs,v)
		using meta
		typedef typeof(v) T
		If hasmember(T,ndim):
			T ret
			For i=0:T.ndim-1
				ret[i]=detail.__commget(ofs,v[i])
		Else
			ret=detail.__commget(ofs,v)
		return ret
with cuda
	const
		PI=3.1415927f
const
	FLT_MAX=__int_as_float(0x7f7fffff)
%divup(int a,int b)=(a+b-1)/b
%align(iptr a,iptr d)=d+((-d)&(a-1))

with spap.detail{
void intGetCounts(char<> buf,int stride,int* ofsret,int nint,int n)
	//shortsort, sort by int id
	/meta.state('metaf-intGetCounts')=meta.curfunc
	logni=((__float_as_int((float)nint)>>23)-127)
	logn=((__float_as_int((float)n)>>23)-127)-8
	if logn<1:logn=1
	aa=(int<>)buf
	tar=(int*)aa.getDevicePointer()+stride*2
	if nint==2:
		//one true split
		int n0;
		forall i=0:n-1
			retid=aa[stride+i]
			n0=split(tar,ccompact_rank_hlp rhlp,retid,target_pointer)
		ofsret[0]=n0
		ofsret[1]=n-n0
		//writeln(buf.n)
		//for i=0:n-1
		//	x=(int2*)(&aa[stride*3])+i
		//	write(x.x,'~',x.y,' ')
		//writeln
		return
	dofsret=new int<nint>
	memset(ofsret,-1,nint*sizeof(int))
	cpyh2d(dofsret.getDevicePointer(),ofsret,nint*sizeof(int))
	//writeln(nint,' ',logni,' ',logn*2)
	if logni<logn*2:
		//scan
		sz=stride
		ab=dnew[n+sz]int2
		a=ab;b=ab+sz
		forall i=0:n-1
			a[i]=make_int2(aa[sz+i],i)
		for(i=0;(1<<i)<nint;i++)
			mk=(1<<i)
			forall j=0:n-1
				split(b,a,a[j].x&mk,target_pointer)
			tmp=b;b=a;a=tmp
		forall i=0:n-1
			xx=a[i]
			id=xx.x
			tar[i]=xx.y
			barrier
			if !i||thread.get(i-1,id)!=id:
				dofsret[id]=i
		ddelete ab
	else
		//sort
		forall id=0:n-1
			//require
			//	thread.block.size=512
			retid=aa[id+stride]
			thread.sortby(retid)
			tar[thread.rank]=id
			barrier
			if !thread.rank||thread.get(thread.rank-1,retid)!=retid:
				dofsret[retid]=thread.rank
	cpyd2h(ofsret,dofsret.getDevicePointer(),nint*sizeof(iptr))
	dofsret.discard()
	ofsret[nint]=n
	for i=nint-1:-1:0
		if ofsret[i]==-1:ofsret[i]=ofsret[i+1]
	for i=0:nint-1
		ofsret[i]=ofsret[i+1]-ofsret[i]

%void intScanCount(int* a,int n)
	c=0
	for i=0:n-1
		a[n+i]=c
		c+=a[i]
}

static interrupt
	#define size __interrupt_count
	#define result __interrupt_result

inline _isnan(float x)=(((__float_as_int(x)&0x7f800000)==0x7f800000)&&(__float_as_int(x)&0x007fffff))
inline _isinf(float x)=((__float_as_int(x)&0x7fffffff)==0x7f800000)
inline _finite(float x)=((__float_as_int(x)&0x7f800000)!=0x7f800000)

If !compiler.getcmdlineoption("CUBSGP_NO_GL"):{
with detail{
//CGLbuffer ppbo
vspnt="!!NVvp4.0
PARAM sz=program.env[0];
INT TEMP a;
TEMP va,b;
MOV.U va,vertex.attrib[0];
MOV.F result.color,va;
SHR.U a.y,va.w,16;
AND.U a.x,va.w,65535;
I2F.U b.x,a.x;
I2F.U b.y,a.y;
MAD.F b.x,b.x,sz.x,sz.z;
MAD.F b.y,b.y,sz.y,sz.w;
MOV.F b.z,0.;
MOV.F b.w,1.;
MOV.F result.position,b;
END"
HGLRC glrc_vspnt=NULL
GLuint hvspnt=0u
void makevspnt()
	.glrc_vspnt=wglGetCurrentContext()
	s=.vspnt
	glGenProgramsARB(1,&.hvspnt);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,.hvspnt);
	glProgramStringARB(GL_VERTEX_PROGRAM_ARB,
		GL_PROGRAM_FORMAT_ASCII_ARB,GLsizei strlen(s),GLubyte* s);
	glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB,&int er);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,0u);
//demolish some GL states
__interrupt__ void glPixel(int p0,int p1,int p2,int p3)
	gl.__glloader_init()
	n=interrupt.size
	thebuf=new int4<n>
	forall i=0:n-1
		thebuf[i]=make_int4(p0[i],p1[i],p2[i],p3[i])
	thebuf_c=new cvec(int4)(n)
	cpyd2h(thebuf_c.d,thebuf.d,n*sizeof(int4))
	thebuf.discard()
	//c=0
	//for i=0:4096/16:n-1
	//	c+=thebuf[i].x
	//if c<0&&c>1:write
	//if !.ppbo:.ppbo=new CGLbuffer
	//.ppbo.clear_resize(n*16)
	//pc=(int4*)(.ppbo.map())
	//spawn n
	//	i=thread.rank
	//	pc[i]=make_int4(p0[i],p1[i],p2[i],p3[i])
	//.ppbo.unmap()
	If !detail.GL_USE_PERMANENT:
		if .glrc_vspnt!=wglGetCurrentContext():.hvspnt=0u
	if !.hvspnt:makevspnt()
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,.hvspnt);
	float[4] gvp
	glGetFloatv(GL_VIEWPORT,gvp)
	tw=gvp[2];th=gvp[3];
	scx=2.f*float(0+1)/float(tw)
	scy=-2.f*float(0+1)/float(th)
	glProgramEnvParameter4fARB(
		GL_VERTEX_PROGRAM_ARB,0u,
		scx,scy,
		-1.f,1.f-1.f*float(0+1)/float(th*2.f))
	glPushClientAttrib(GL_CLIENT_VERTEX_ARRAY_BIT)
	//.ppbo.bind(GL_ARRAY_BUFFER)
	glEnable(GL_VERTEX_PROGRAM_ARB)
	glEnableVertexAttribArray(0u)
	glVertexAttribIPointerEXT(0u,4,GL_INT,16,thebuf_c.d)
	glDrawArrays(GL_POINTS,0,n)
	glDisableVertexAttribArray(0u)
	//glBindBuffer(GL_ARRAY_BUFFER,0u);
	glDisable(GL_VERTEX_PROGRAM_ARB)
	glPopClientAttrib()
	:done
}
__device__ void glPixel(int x,int y,float3 c)
	pi=(int*)&c
	detail.glPixel(pi[0],pi[1],pi[2],(y<<16)+x)
}

//memory statistics
with cuda.detail
	static cbinbuddy
		iptr peak_used
			&get()=(iptr*()()spapGetGpuApi("cudaGetPeakMem"))()
			set(iptr a)*(iptr*()()spapGetGpuApi("cudaGetPeakMem"))()=a
		iptr total_alloc
			&get()=(iptr*()()spapGetGpuApi("cudaGetTotalMem"))()
			set(iptr a)*(iptr*()()spapGetGpuApi("cudaGetTotalMem"))()=a
		void dumpblocks()
			(void()()spapGetGpuApi("cudaDumpBlocks"))()

void cudaDumpBlocks()(void()()spapGetGpuApi("cudaDumpBlocks"))()
u32 cudaMaxFreeBlock()=(u32()()spapGetGpuApi("cudaMaxFreeBlock"))()
void cudaDisableAllocation()(void()()spapGetGpuApi("cudaDisableAllocation"))()
void cudaEnableAllocation()(void()()spapGetGpuApi("cudaEnableAllocation"))()
void cudaDisableOutOfMemoryError()(void()()spapGetGpuApi("cudaDisableOutOfMemoryError"))()
void cudaEnableOutOfMemoryError()(void()()spapGetGpuApi("cudaEnableOutOfMemoryError"))()
int cudaDestroyEverything()=(int()()spapGetGpuApi("cudaDestroyEverything"))()
void cudaDefragMemory()(void()()spapGetGpuApi("cudaDefragMemory"))()
void cudaDoNotDefrag(void* p)(void()(void*)spapGetGpuApi("cudaDoNotDefrag"))(p)
void cudaUnmapFromHost(void* p)(void()(void*)spapGetGpuApi("cudaUnmapFromHost"))(p)
//pkrnl is the __kernel in the launcher wrapper
void* cudaGetFunctionHandle(void* pkrnl)=(void*()(void*)spapGetGpuApi("cudaGetFunctionHandle"))(pkrnl)
%maxfreeblocku()=cudaMaxFreeBlock()
%maxfreeblock()=(int)cudaMaxFreeBlock()
struct TCudaAllocationBlock
	void* p
	iptr sz
TCudaAllocationBlock* cudaGetAllocatedBlocks(int* pn)
	return (TCudaAllocationBlock*()(int*)spapGetGpuApi("cudaGetAllocatedBlocks"))(pn)
void cudaDisableBlockMerging()(void()()spapGetGpuApi("cudaDisableBlockMerging"))()
void cudaEnableBlockMerging()(void()()spapGetGpuApi("cudaEnableBlockMerging"))()
int cudaReleaseAllocatedBlock(int id)=(int()(int)spapGetGpuApi("cudaReleaseAllocatedBlock"))(id)
void* cudaTrueAllocd(iptr sz)=(void*()(iptr)spapGetGpuApi("cudaTrueAllocd"))(sz)
const
	CUDA_CHECK_NONE=0
	CUDA_CHECK_SYNC=1
	CUDA_CHECK_SETPIXEL=2
void cudaSetAutoCheckLevel(iptr lv)
	(void()(iptr)spapGetGpuApi("cudaSetAutoCheckLevel"))(lv)

%void cubsgpInit()
	mylazyinit()

//advanced launch method
with $$cuda{
void cudevPersistent()
	const
		NUM_POOLS=64
	using function_global,meta
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	n_true_thread=ncore*1024
	pool=dnew int[NUM_POOLS]
	int[NUM_POOLS] poolc
	for i=0:NUM_POOLS-1
		poolc[i]=i
	cpyh2d(pool,poolc,sizeof(poolc))
	__asm__("@@param maker")
	defglobal iptr __thread_size
	defglobal void* __kernel
	defglobal void* __param
	defglobal iptr __szparam
	//hf=cudaGetFunctionHandle(__kernel)
	spapLaunch(__kernel,n_true_thread,__param,__szparam)
	spawn 1
		defglobal iptr __thread_rank
		for(;;)
			rk0=__asm__("@return",meta.typeid(iptr),"=blockIdx.x*blockDim.x+threadIdx.x")
			myid=rk0&(NUM_POOLS-1)
			rk=atomicAdd(&pool[myid],NUM_POOLS)
			if rk>=__thread_size:break
			__thread_rank=rk
			__asm__("@@kernel body")
	ddelete pool

void cudevTimedPersistent()
	const
		NUM_POOLS=32
	using function_global,meta
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	n_true_thread=ncore*1024
	pool=dnew int[NUM_POOLS+1]
	int[NUM_POOLS+1] poolc
	for i=0:NUM_POOLS-1
		poolc[i]=i
	poolc[NUM_POOLS]=0
	cpyh2d(pool,poolc,sizeof(poolc))
	__asm__("@@param maker")
	defglobal iptr __thread_size
	defglobal void* __kernel
	defglobal void* __param
	defglobal iptr __szparam
	:again
	er=cuCtxSynchronize()
	$$cuda.lasterror=er
	checkpoint("repeated time-launch")
	spapLaunch(__kernel,n_true_thread,__param,__szparam)
	cpyd2h(poolc,pool,sizeof(poolc))
	for i=0:NUM_POOLS-1
		if poolc[i]<__thread_size:
			poolc[NUM_POOLS]=0
			cpyh2d(pool,poolc,sizeof(poolc))
			goto again
	spawn 1
		defglobal iptr __thread_rank
		if !pool[NUM_POOLS]:
			tick=0u
			for(;;)
				rk0=__asm__("@return",meta.typeid(iptr),"=blockIdx.x*blockDim.x+threadIdx.x")
				myid=rk0&(NUM_POOLS-1)
				rk=atomicAdd(&pool[myid],NUM_POOLS)
				if rk>=__thread_size:break
				t0=clock()
				__thread_rank=rk
				__asm__("@@kernel body")
				tick+=((u32)(clock()-t0)+1023u)>>10u
				if tick>=0x100000u:
					//sound alarm
					pool[NUM_POOLS]=1
					break
	ddelete pool

}
